<?php include_once('../../../config.php') ?>

<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <title>Sisplan Web | Cadastro de Turnos</title>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="dist/css/adminlte.min.css?versao=3.231.25.1">
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=3.231.25.1">
  <link href='https://fonts.googleapis.com/css?family=Roboto:400,300,500,600,700,400italic' rel='stylesheet' type='text/css'>
  <link rel="stylesheet" type="text/css" href="dist/css/dataTables.bootstrap4.min.css?versao=3.231.25.1" />
  <link href='dist/css/bootstrap.min.css?versao=3.231.25.1'>
  <link rel="stylesheet" href="dist/css/custom.css?versao=3.231.25.1">
  <link rel="stylesheet" href="dist/css/sisplan.css?versao=3.231.25.1">
  <link rel="stylesheet" type="text/css" href="plugins/datatables-keytable/css/keyTable.bootstrap4.min.css?versao=3.231.25.1">
  <link rel="stylesheet" type="text/css" href="dist/css/responsive.bootstrap.min.css?versao=3.231.25.1">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="stylesheet" href="dist/css/cadastro.css?versao=3.231.25.1">
  <link rel="stylesheet" href="plugins/toastr/toastr.min.css?versao=3.231.25.1">
  <link rel="stylesheet" type="text/css" href="dist/css/driver.min.css?versao=3.231.25.1" />
  <link rel="stylesheet" href="dist/css/jquery-ui.css?versao=3.231.25.1">
  <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
  <style>
    #tabelaTurno td div button {
      padding: .0rem .5rem;
      margin-top: .1rem;
      margin-bottom: .2rem;
    }

    #tabelaTurno td {
      padding: 0 !important;
      padding-left: 10px !important;
    }

  </style>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">
    <?php
    include_once('../../../menu.php');
    ?>

    <div id="myModal" class="modal" tabindex="-1" role="dialog">
      <div class="modal-dialog" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 id="myModalLabel" class="modal-title"></h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <p id="myModalText"></p>
          </div>
          <div class="modal-footer">
            <button id="btnYes" type="button" class="btn btn-primary">Sim</button>
            <button id="btnNo" type="button" class="btn btn-secondary" data-dismiss="modal">Não</button>
          </div>
        </div>
      </div>
    </div>

    <div class="content-wrapper">
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6 flex">
              <h1 class="m-0 text-dark">Cadastro de Horários dos Turnos</h1>
              <button type="button" class="btn btn-info btn-sm ml-2" title="Tutorial" style="color: white;" id="tutorial">
                <i class="fas fa-question-circle"></i></button>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="./index">Início</a></li>
                <li class="breadcrumb-item active">Acesso Cadastro de Horários dos Turnos</li>
              </ol>
            </div>
          </div>
        </div>
        
        <div class="container-fluid" id="tabelBancoForne">

          <div class="row card">
            <div class="col-sm-12 mt-3">
              <button class="btn btn-success btn-sisp" id="btnFiltros"><span class="fas fa-search"></span> Filtros</button>
              <button class="btn btn-danger btn-sisp" id="btnNovoTemplate" onclick='window.location.href = "cadhorarios/create";'><span class="fas fa-plus"></span> Incluir</button>
            </div>
            
            <div class="col-sm-12 table-responsive card-body">
              <h5>Lista de Horários dos Turnos</h5>
              <table id="tabelaTurno" class="table table-sm table-select table-hover" width="100%"></table>
              <thead>
                <tr></tr>
              </thead>
              <tbody>
                <tr></tr>
              </tbody>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div id="modal-filtros" class="modal" tabindex="-1" role="dialog">
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content" id="modalBody">
          <div class="modal-header">
            <h4 class="modal-title">Filtros</h4>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">
            <div class="row">
              <div class="col-12" id="MarcaInfoTour">
                <label data-error="wrong" data-success="right" for="txtCadTurnoConsulta">Consulta de Turnos </label>
                <div class="input-group">
                  <input type="text" autocomplete="off" class="input-default focus form-control" id="txtCadStatusConsulta" name="txtCadStatusConsulta" class="form-control" placeholder="Código">
                  <div class="input-group-append">
                    <button class="btn bg-danger" id="btn-ConsultaTurnos" name="btn-ConsultaTurnos" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                    <button class="btn bg-danger" id="btn-limpa-ConsultaTurnos" name="btn-limpa-ConsultaTurnos" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <div class="row">
              <button class="btn btn-primary btn-sisp" id="btnLimparFiltros" style="background-color: #B22222; border-color: #B22222"><span class="fas fa-trash"></span> Limpar Filtros</button>     
              <button class="btn btn-primary btn-sisp" id="btnConsultar"><span class="fas fa-search"></span> Consultar</button>
            </div>
          </div>
        </div>
      </div>
    </div>

    <?php
    include_once('../../../footer.php');
    ?>
    <aside class="control-sidebar control-sidebar-dark">
    </aside>
  </div>
  <script src="plugins/jquery/jquery.min.js?versao=3.231.17.1"></script>
  <script src="plugins/jquery-ui/jquery-ui.min.js?versao=3.231.17.1"></script>
  <script type="text/javascript" src="dist/js/jquery.dataTables.js?versao=3.231.17.1"></script>
  <script type="text/javascript" src="dist/js/dataTables.bootstrap4.min.js?versao=3.231.17.1"></script>
  <script src="plugins/sweetalert2/sweetalert2.min.js?versao=3.231.17.1"></script>
  <script src="plugins/toastr/toastr.min.js?versao=3.231.17.1"></script>
  <script>
    $.widget.bridge('uibutton', $.ui.button);
  </script>
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/adminlte.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/requisicoes.js?versao=3.231.17.1"></script>
  <script src="dist/js/cliente/entidade.js?versao=3.231.17.1"></script>
  <script src="dist/js/loadingoverlay.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/valida_cpf_cnpj.js"></script>
  <script src="plugins/jquery-validation/jquery.validate.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/sisplan.js?versao=3.231.17.1"></script>
  <script src="utils/funcoes.js?versao=3.231.17.1"></script>
  <script src="utils/cookies.js?versao=3.231.17.1"></script>
  <script src="dist/js/jquery.maskMoney.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/driver.min.js?versao=3.231.17.1"></script>
  <script src="dist/js/dataTables.keyTable2.js?versao=3.231.17.1"></script>
  <script type="text/javascript" src="config.js?versao=3.231.17.1"></script>
  <script>
    $(document).ready(async function() {
      if (getCookie('usuario') == "") {
        window.location.href = `${BASE_URI}/login`;
        return;
      }

      let usuario = getCookie('usuario');
      let empresa = getCookie('empresa');

      ipInterno = IP_INTERNO;
      ipExterno = IP_EXTERNO;
      basicAuth = BASIC_AUTH;

      const temAcesso = await temAcessoTela('CADHORARIOS');
      if (!temAcesso.resultado) {
        toastrAcesso(temAcesso, BASE_URI);
        return;
      }

      sArquivo = `${BASE_URI}/pages/cadhorarios/acesso_cadhorarios/acesso_cadhorarios.js?versao=3.231.17.1`;
      insereJavaScriptPagina(sArquivo);

      const nomeTela = ('<?php echo basename(__FILE__) ?>').replace('.php', '');
      habilitaCamposObrigatoriosTela(nomeTela);
    });
  </script>
</body>

</html>