$("#tutorial").on("click", function () {
    $(document).ready(async function () {
        const driver = new Driver({
            doneBtnText: "Sair",
            closeBtnText: "Fechar",
            nextBtnText: "Próximo",
            prevBtnText: "Anterior",
            allowClose: false,
            animate: true,
        });

        driver.defineSteps([
            {
                element: "#campostuto",
                popover: {
                    title: "Dados Gerais",
                    description: "Aqui estão os campos disponíveis para o cadastro.",
                    position: "top",
                },
            },
            {
                element: "#txtCodigo",
                popover: {
                    title: "Campos Obrigatórios",
                    description:
                        "Esse é um campo obrigatório, para identificá-los, você verá um * ao lado do nome.",
                    position: "top",
                },
            },
            {
                element: "#txtDescricao",
                popover: {
                    title: "Campos Obrigatórios",
                    description:
                        "Este campo tem por sua funcionalidade conter a descrição do nome do Histórico.",
                    position: "top",
                },
            },
            {
                element: "#gravar",
                popover: {
                    title: "Botão Gravar",
                    description: "Clique aqui para gravar um Histórico.",
                    position: "left",
                },
            },
        ]);
        driver.start();
    });
});

$(document).ready(async function () {

    await filtrosConsultaCheque();
    const parametro3Receber = await CopiaParametro("RECEBER", 3);
    await setarDataAtual('dtEmissao');
    $('#dtEmissao').prop('disabled', true);
    $('#dtEmissao').prop('readonly', true);

    if (parametro3Receber == '1') {
        $('#caixa').removeClass('d-none');
        $('#moeda').removeClass('d-none');
    } else {
        $('#nrCaixa').addClass('d-none');
        $('#Moeda').addClass('d-none');
    }

    // criaDataTablePadrao('#tabelaCheque', false, true, false, false, true, true, '150px');

    let queryString = window.location.href;
    let parametros = queryString.split("/");
    let numero = parametros[parametros.length - 1];

    async function filtrosConsultaCheque() {
        //AUTOCOMPLETE
        $('#txtCliente').autocompleta(1, `JSON={ "tabela": "ENTIDADE", "camposSelect":[ "CODCLI CHAVE", "NOME DESCRICAO"], "where": null }`);
        $('#txtRepresentante').autocompleta(1, `JSON={ "tabela": "REPRESEN", "camposSelect":[ "CODREP CHAVE", "NOME DESCRICAO"], "where": null }`);
        $('#txtHistorico').autocompleta(1, `JSON={ "tabela": "HISTCO", "camposSelect":[ "HISTORICO CHAVE", "DESCRICAO DESCRICAO"], "where": null }`);
        $('#txtClasse').autocompleta(1, `JSON={ "tabela": "CLASSE_GER", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null }`);
        $('#txtSituacao').autocompleta(1, `JSON={ "tabela": "TABSIT", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null }`);
        $('#txtSituacao').autocompleta(1, `JSON={ "tabela": "TABSIT", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null }`);
        $("#txtBanco").autocompleta(1, `JSON={ "tabela":"cadban", "camposSelect":[ "banco chave", "nome_banco descricao"], "where": null}`);
        $('#txtCaixa').autocompleta(2, `JSON={ "tabela":"caixa_loja", "camposSelect":[ "codigo CHAVE", "descricao"], "where": null}`);
        $('#txtMoeda').autocompleta(1, `JSON={ "tabela":"moeda", "camposSelect":[ "codmoe CHAVE", "descricao"], "where": null}`);

        //SEARCH ALL
        $('#btnCliente').pesquisa_serverside(['#txtCliente'], ['CODCLI'], ['NOME'], '{"tabela":"ENTIDADE", "camposSelect":[ "CODCLI", "NOME"], "where": null}', 'Pesquisa Cliente');
        $("#btnRepresentante").pesquisa_serverside(["#txtRepresentante"], ["CODREP"], ["NOME"], '{"tabela":"REPRESEN", "camposSelect":[ "CODREP", "NOME"], "where": null}', "Pesquisa Representante");
        $("#btnHistorico").pesquisa("#txtHistorico", "HISTORICO", "DESCRICAO", `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"HISTCP", "camposSelect":[ "HISTORICO", "DESCRICAO"], "where": null}`, "Pesquisa Histórico", "HISTCP");
        $("#btnClasse").pesquisa("#txtClasse", "CODIGO", "DESCRICAO", `/sipslan/funcoes/v1/pesquisa?JSON={ "tabela":"CLASSE_GER", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}`, "Pesquisa Classe Gerencial", "CLASSE_GER");
        $('#btnSituacao').pesquisa("#txtSituacao", "CODIGO", "DESCRICAO", `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"TABSIT", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}`, "Pesquisa Situação", "TABSIT");
        $("#btnBanco").pesquisa("#txtBanco", "BANCO", "NOME_BANCO", `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"cadban", "camposSelect":[ "banco", "nome_banco"]}`, "Pesquisa Banco", "cadban");
        $('#btnCaixa').pesquisa('#txtCaixa', 'CODIGO', 'DESCRICAO', '/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"caixa_loja", "camposSelect":[ "codigo", "descricao"], "where": null}', 'Pesquisa Caixa', 'caixa_loja');
        $('#btnMoeda').pesquisa('#txtMoeda', 'CODIGO', 'DESCRICAO', '/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"moeda", "camposSelect":[ "codmoe codigo", "descricao"], "where": null}', 'Pesquisa Moeda', 'moeda');
    }

    //CLEAN INDIVIDUALLY FILTERS
    $('#btnLimpaCliente').on('click', function () {
        $('#txtCliente').val('');
    });
    $('#btnLimpaRepresentante').on('click', function () {
        $('#txtRepresentante').val('');
    });
    $('#btnLimpaHistorico').on('click', function () {
        $('#txtHistorico').val('');
    });
    $('#btnLimpaClasse').on('click', function () {
        $('#txtClasse').val('');
    });
    $('#btnLimpaSituacao').on('click', function () {
        $('#txtSituacao').val('');
    });
    $('#btnLimpaBanco').on('click', function () {
        $("#txtBanco").val('');
    });
    $('#btnLimpaConta').on('click', function () {
        $('#txtConta').val('');
    });
    $('#btnLimpaMoeda').on('click', function () {
        $('#txtMoeda').val('');
    });
    $('#btnLimpaCaixa').on('click', function () {
        $('#txtCaixa').val('');
    });

    let options = {
        onKeyPress(cpf, ev, el, op) {
            let masks = ["000.000.000-000", "00.000.000/0000-00"];
            $("#txtCNPJ").mask(cpf.length > 14 ? masks[1] : masks[0], op);
        },
    };

    if ($("#txtCNPJ").length > 11) {
        $("#txtCNPJ").mask("00.000.000/0000-00", options);
    } else {
        $("#txtCNPJ").mask("000.000.000-00#", options);
    }

    $("#txtCNPJ").on('change', function () {
        let validaCNPJ = formata_cpf_cnpj($("#txtCNPJ").val());
        if (validaCNPJ != false) {
            $("#txtCNPJ").val(validaCNPJ);
        }
    });

    if (numero != "" && numero != "create") {
        if ((await liberarRegistro("CHEQUE", numero)) == false) {
            window.location.href = "../cheque";
        } else {
            try {
                $.LoadingOverlay("show");
                try {
                    let response = await requisicao(
                        "GET",
                        "/Sisplan/Funcoes/v1/pesquisa?",
                        `JSON={ "tabela":"RECEBER", 
                      "camposSelect":["CODCLI", "CODREP", "HISTORICO", "CLASSE", "SITUACAO", "NUMERO_CH", "BANCO_CH", "CONTA_CH", "AGENCIA_CH", "DT_EMISSAO", "DT_VENCTO", "VALOR", "EMISSOR_CH", "CNPJ_CH", "BARRA_CH"], "where": ["NUMERO_CH = '${numero}' AND STATUS='CHEQ'"]}`,
                        null
                    );

                    if (!response) {
                        return;
                    }
                    let jsonStr = await response.json();
                    if (response.status != 200) {
                        msgAlerta(jsonStr.RESULT[0].mensagem);
                        return;
                    }

                    await concatenaCliente(jsonStr.RESULT[0][0].CODCLI);
                    await concatenaRepresentante(jsonStr.RESULT[0][0].CODREP);
                    await concatenaHistorico(jsonStr.RESULT[0][0].HISTORICO);
                    await concatenaClasse(jsonStr.RESULT[0][0].CLASSE);
                    await concatenaSituacao(jsonStr.RESULT[0][0].SITUACAO);
                    $("#txtNumero").val(jsonStr.RESULT[0][0].NUMERO_CH);
                    await concatenaBanco(jsonStr.RESULT[0][0].BANCO_CH);
                    $("#txtConta").val(jsonStr.RESULT[0][0].CONTA_CH);
                    $("#txtAgencia").val(jsonStr.RESULT[0][0].AGENCIA_CH);
                    $("#dtEmissao").val(jsonStr.RESULT[0][0].DT_EMISSAO);
                    $("#dtVencimento").val(jsonStr.RESULT[0][0].DT_VENCTO);
                    $("#txtValor").val(jsonStr.RESULT[0][0].VALOR);
                    $("#txtEmissor").val(jsonStr.RESULT[0][0].EMISSOR_CH);
                    $("#txtCNPJ").val(jsonStr.RESULT[0][0].CNPJ_CH);
                    $("#txtBarra").val(jsonStr.RESULT[0][0].BARRA_CH);

                } catch (error) {
                    console.error(error);
                    msgAlerta(`Não foi possível buscar os dados:`);
                }
            } finally {
                $.LoadingOverlay("hide");
            }
        }
    }

    async function concatenaCliente(sCodCli) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"ENTIDADE", 
              "camposSelect":["NOME"], 
              "where": ["CODCLI = '${sCodCli}'"]}`,
            null
        );
        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtCliente"), sCodCli, jsonString.RESULT[0][0].NOME);
        }
        return
    }

    async function concatenaRepresentante(sCodRep) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"REPRESEN", 
              "camposSelect":["NOME"], 
              "where": ["CODREP = '${sCodRep}'"]}`,
            null
        );
        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtRepresentante"), sCodRep, jsonString.RESULT[0][0].NOME);
        }
        return
    }

    async function concatenaHistorico(sHistorico) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"HISTCP", 
              "camposSelect":["DESCRICAO"], 
              "where": ["HISTORICO = '${sHistorico}'"]}`,
            null
        );
        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtHistorico"), sHistorico, jsonString.RESULT[0][0].DESCRICAO);
        }
        return
    }

    async function concatenaClasse(sClasse) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"CLASSE_GER", 
              "camposSelect":["DESCRICAO"], 
              "where": ["CODIGO = '${sClasse}'"]}`,
            null
        );
        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtClasse"), sClasse, jsonString.RESULT[0][0].DESCRICAO);
        }
        return
    }

    async function concatenaSituacao(sSituacao) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"TABSIT", 
              "camposSelect":["DESCRICAO"], 
              "where": ["CODIGO = '${sSituacao}'"]}`,
            null
        );

        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtSituacao"), sSituacao, jsonString.RESULT[0][0].DESCRICAO);
        }
        return
    }

    async function concatenaBanco(sBanco) {
        let resposta = await requisicao(
            "GET",
            "/Sisplan/Funcoes/v1/pesquisa?",
            `JSON={ "tabela":"CADBAN", 
              "camposSelect":["NOME_BANCO"], 
              "where": ["BANCO = '${sBanco}'"]}`,
            null
        );

        let jsonString = await resposta.json();
        if (jsonString.RESULT[0] != 0) {
            insereValor($("#txtBanco"), sBanco, jsonString.RESULT[0][0].NOME_BANCO);
        }
        return;
    }


    // $('#txtNumero').on('blur', async function () {
    //     if ($('#txtNumero').val() == '') {
    //         $('#txtNumero').val(await RetornaProximo('RECEBER', 'RECEBER', 'NUMERO_CH', 6));
    //     }
    // });

    $("#btnVoltar").on("click", async function () {
        await deletaRegistro("CHEQUE", getCookie("usuario"), parametros[5]);
        window.location.href = `${BASE_URI}/cheque`;
    });

    async function validaData() {
        dtEmissao = $("#dtEmissao").val();
        dtVencimento = $('#dtVencimento').val();

        if (dtEmissao > dtVencimento) {
            msgAlerta('Data de emissão maior que a data de vencimento!')
            return;
        }
    }

    $("#gravar").click(async function () {
        let validator = $("#msform").validate();
        validator.form();
        let erros = 0;
        erros = validator.numberOfInvalids();

        let geraCaixaLoja = false;
        if (parametro3Receber == '1') {
            await msgAlerta(
                'Deseja lançar o valor do cheque no caixa?',
                async function () {
                    if (pegaChave('#txtCaixa') == '') {
                        msgAlerta('Necessário informar o campo caixa!');
                        return;
                    }
                    if (pegaChave('#txtMoeda') == '') {
                        msgAlerta('Necessário informar o campo moeda!');
                        return;
                    }
                    geraCaixaLoja = true;
                    if (await validaCaixa(geraCaixaLoja)) {
                        gravaReceber();
                    }
                },
                async function () {
                    geraCaixaLoja = false;
                    if (await validaCaixa(geraCaixaLoja)) {
                        gravaReceber();
                    }
                }
            );
        } else {
            if (await validaCaixa(geraCaixaLoja)) {
                gravaReceber();
            }
        }

        async function gravaReceber() {
            if (erros == 0) {
                try {
                    $.LoadingOverlay("show");
                    await validaData();
                    await verificaCamposPreenchidos();
                    let ChequeClasse = {};
                    ChequeClasse.NUMERO_CH = $('#txtNumero').val();
                    ChequeClasse.CODCLI = pegaChave("#txtCliente");
                    ChequeClasse.CODREP = pegaChave('#txtRepresentante');
                    ChequeClasse.HISTORICO = pegaChave("#txtHistorico");
                    ChequeClasse.CLASSE = pegaChave("#txtClasse");
                    ChequeClasse.SITUACAO = pegaChave('#txtSituacao');
                    ChequeClasse.BANCO_CH = pegaChave("#txtBanco");
                    ChequeClasse.CONTA_CH = $("#txtConta").val();
                    ChequeClasse.AGENCIA_CH = $('#txtAgencia').val();
                    ChequeClasse.DT_EMISSAO = $("#dtEmissao").val();
                    ChequeClasse.DT_VENCTO = $("#dtVencimento").val();
                    ChequeClasse.VALOR2 = parseFloat($('#txtValor').val().replace('.', '').replace(',', '.'));
                    ChequeClasse.EMISSOR_CH = $("#txtEmissor").val();
                    ChequeClasse.CNPJ_CH = $("#txtCNPJ").val();
                    ChequeClasse.BARRA_CH = $("#txtBarra").val();
                    ChequeClasse.NUMERO = await RetornaProximo('RECEBER', 'RECEBER', 'NUMERO', 6);
                    ChequeClasse.EMP_ID = getCookie('emp_id');
                    ChequeClasse.GERACAIXALOJA = geraCaixaLoja;
                    ChequeClasse.NRCAIXA = pegaChave('#txtCaixa');
                    ChequeClasse.MOEDA = pegaChave('#txtMoeda');
                    ChequeClasse.OBS = isChecked('#cbLancarAnte') ? `Criado antecipação para cheque ${$('#txtNumero_CH').val()}` : '';

                    let response = await requisicao(
                        'POST', `/sisplan/cadastros/v1/cheque?`, '', JSON.stringify(ChequeClasse), 15000
                    );

                    if (!response) {
                        $.LoadingOverlay("hide");
                        return;
                    }

                    if (response.status != 200) {
                        let jsonStr = await response.json();
                        $.LoadingOverlay("hide");
                        msgAlerta(jsonStr.mensagem);
                        return;
                    }

                    if (isChecked('#cbLancarAnte')) {
                        const receberClass = {
                            VALOR: ChequeClasse.VALOR2,
                            VALOR2: ChequeClasse.VALOR2,
                            DT_EMISSAO: ChequeClasse.DT_EMISSAO,
                            DT_VENCTO: ChequeClasse.DT_VENCTO,
                            STATUS: 'ANTE',
                            OBS: `Antecipação do cheque ${ChequeClasse.NUMERO_CH}.`,
                            CODREP: ChequeClasse.CODREP,
                            CODCLI: ChequeClasse.CODCLI,
                            SITUACAO: ChequeClasse.SITUACAO,
                            CLASSE: ChequeClasse.CLASSE,
                            BANCO: ChequeClasse.BANCO_CH,
                            NRCAIXA: ChequeClasse.NRCAIXA,
                            MOEDA: ChequeClasse.MOEDA,
                            CONTA_CH: ChequeClasse.CONTA_CH,
                            NUMERO_CH: ChequeClasse.NUMERO_CH
                        };

                        response = await requisicao('POST', '/Sisplan/receber/V1/Receber?', '', `JSON=${encodeURIComponent(JSON.stringify(receberClass))}`);

                        if (!response) {
                            return;
                        }

                        let jsonStr = await response.json();

                        if (response.status != 200) {
                            msgErro(jsonStr.RESULT[0].mensagem);
                            return;
                        }
                    }

                    $.LoadingOverlay("hide");
                    toastr
                        .success(
                            `Cadastro efetuado com sucesso!
                               Cheque: ${ChequeClasse.NUMERO_CH}`,
                            "Confirmação",
                            {
                                toastClass: "alert",
                                iconClasses: {
                                    error: "alert-error",
                                    info: "alert-info",
                                    success: "alert-success",
                                    warning: "alert-warning",
                                },
                                positionClass: "toast-top-center",
                                progressBar: true,
                                timeOut: 3000,
                                fadeOut: 1000,
                                onHidden() {
                                    window.location.href = `${BASE_URI}/cheque`;
                                },
                            }
                        )
                        .css({
                            "margin-top": "20%",
                            width: "500px",
                            "max-width": "500px",
                        });
                } catch (error) {
                    console.error(error);
                    $.LoadingOverlay("hide");
                    msgAlerta(`Não foi possível gravar os dados:`);
                }
            }
        }
    });

    async function verificaCamposPreenchidos() {
        $.LoadingOverlay('show')
        try {
            if ($('#txtCliente').val() === '') {
                msgAlerta(`Necessário informar um cliente.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtRepresentante').val() === '') {
                msgAlerta(`Necessário informar um representante.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtHistorico').val() === '') {
                msgAlerta('Necessário informar um histórico.');
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtClasse').val() === '') {
                msgAlerta(`Necessário informar uma classe.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtSituacao').val() === '') {
                msgAlerta(`Necessário informar uma situação.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtNumero').val() === '') {
                msgAlerta('Necessário informar um número.');
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtBanco').val() === '') {
                msgAlerta(`Necessário informar um banco.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtConta').val() === '') {
                msgAlerta(`Necessário informar uma conta.`);
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtAgencia').val() === '') {
                msgAlerta('Necessário informar um agência.');
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtValor').val() === '') {
                msgAlerta('Necessário informar um valor.');
                $.LoadingOverlay("hide");
                return;
            }

            if ($('#txtEmissor').val() === '') {
                msgAlerta('Necessário informar um emissor.');
                $.LoadingOverlay("hide");
                return;
            }
            if ($('#dtEmissao').val() === '') {
                msgAlerta('Necessário informar uma data de emissão.');
                $.LoadingOverlay('hide');
                return;
            }
            if ($('#dtVencimento').val() === '') {
                msgAlerta('Necessário informar uma data de vencimento.');
                $.LoadingOverlay('hide');
                return;
            }
        } catch (error) {
            console.log(error)
        } finally {
            $.LoadingOverlay("hide");
        }
    }

    $(function () {
        $('#txtValor').maskMoney({
            decimal: ',',
            thousands: '.',
            precision: 2,
            allowZero: true,
            defaultZero: true,
            min: 0,
            max: 99
        });
    });


    async function validaCaixa(bGeraCaixa) {
        if (bGeraCaixa) {
            const bCaixaFechado = await CaixaFechado(pegaChave('#txtCaixa'), $('#dtEmissao').val());
            return !bCaixaFechado;
        } else {
            return true;
        }
    };

    async function CaixaFechado(caixa, data) {
        try {
            $.LoadingOverlay('show');
            try {
                let response = await requisicao('GET', '/Sisplan/vendas/V1/VerificaStatusCaixa?',
                    `CAIXA=${caixa}&DATA=${data}`, null);

                if (!response) {
                    return false;
                }

                var jsonStr = await response.json();
                if (response.status != 200) {
                    msgErro(jsonStr.mensagem);
                    return false;
                }

                if (jsonStr == "true") {
                    const dataFormatada = new Intl.DateTimeFormat("pt-BR").format(
                        new Date(`${$('#dtEmissao').val().split(" ")[0]} 23:59:59`)
                    );
                    msgAlerta(`Caixa já fechado para a data ${dataFormatada}. Para lançar o valor no caixa será necessário reabrir o mesmo.`);
                    return true;
                }

            } catch (error) {
                console.error(error);
                $.LoadingOverlay("hide");
                msgErro('Erro ao verificar se o caixa está fechado ou aberto!');
            }
        } finally {
            $.LoadingOverlay('hide');
        }
    }
});