<?php include_once('../../../config.php') ?>

<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <title>Sisplan Web | Ramo Atuação</title>
  <!-- Tell the browser to be responsive to screen width -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=3.232.3.1">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css?versao=3.232.3.1">

  <!-- Google Font: Source Sans Pro -->
  <link href='https://fonts.googleapis.com/css?family=Roboto:400,300,500,600,700,400italic' rel='stylesheet' type='text/css'>


  <link rel="stylesheet" href="dist/css/custom.css?versao=3.232.3.1">
  <link rel="stylesheet" href="dist/css/sisplan.css?versao=3.232.3.1">
  <link rel="stylesheet" type="text/css" href="dist/css/dataTables.bootstrap4.min.css?versao=3.232.3.1" />
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="stylesheet" type="text/css" href="dist/css/driver.min.css?versao=3.232.3.1" />
  <link rel="stylesheet" href="plugins/toastr/toastr.min.css?versao=3.232.3.1">

</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">

    <?php
    include_once('../../../menu.php');
    ?>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6 flex">
              <h1 class="m-0 text-dark">Cadastro de Ramo Atuação</h1>
              <button type="button" class="btn btn-info btn-sm ml-2" title="Tutorial" style="color: white;" id="tutorial">
                <i class="fas fa-question-circle"></i></button>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="index">Início</a></li>
                <li class="breadcrumb-item active">Cadastro de Ramo Atuação</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div>
        <div class="container-fluid">
          <div class="row card">
            <div class="col-sm-12 mt-3">
              <button class="btn btn-success btn-sisp" id="btnFiltros" type="button"><span class="fas fa-filter"></span> Filtros</button>
              <button class="btn btn-danger btn-sisp" id="btnIncluir"><span class="fas fa-plus"></span> Incluir</button>
              <button class="btn btn-secondary btn-sisp" id="btnImprimir"><span class="fas fa-print pr-1" style="color: white!important"></span></span> Imprimir</button>
            </div>
            <div class="col-sm-12 table-responsive card-body" id="divTabelaRamoAtuacao">
              <h5>Lista de itens</h5>
              <table id="tabelaRamoAtuacao" class="table table-sm table-select table-hover" width="100%">
                <thead>
                  <tr>
                    <th class="th-sm">Código
                    </th>
                    <th class="th-sm">Descrição
                    </th>
                    <th class="th-sm">Tipo
                    </th>
                  </tr>
                </thead>
                <tbody>

                </tbody>
              </table>
            </div>
          </div>
        </div>

        <div id="modal-filtros" class="modal" tabindex="-1" role="dialog">
          <div class="modal-dialog modal-xl" role="document">
            <div class="modal-content" id="modalBody">
              <div class="modal-header">
                <h4 class="modal-title">Filtros</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">

                <div class="row">
                  <div class="col-sm-12 col-lg-8">
                    <label data-error="wrong" class="labelGeral" data-success="right" for="txtRamoAtuacao">Ramo Atuação</label>
                    <div class="input-group">
                      <input type="text" class="input-default focus form-control" id="txtRamoAtuacao" name="txtRamoAtuacao" class="form-control" placeholder="Ramo Atuação">
                      <div class="input-group-append">
                        <button class="btn bg-danger" id="btnRamoAtuacao" name="btnRamoAtuacao" data-button="absolute" type="button">
                          <i class="m-0 p-0 fas fa-search"></i>
                        </button>
                        <button class="btn bg-danger" id="btnARamoAtuacao" type="button">
                          <i class="m-0 p-0 fas fa-trash"></i>
                        </button>
                      </div>
                    </div>
                  </div>
                  <div class="group-default form-group col-sm-12 col-lg-4">
                    <label for="">Tipo: </label>
                    <div class="relative">
                      <select name="" id="selectTipo" value="" class="form-group input-default">
                        <option value="">Todos</option>
                        <option value="T">Título</option>
                        <option value="A">Analítica</option>
                      </select>
                    </div>
                  </div>
                </div>
              </div>

              <div class="modal-footer">
                <div class="row">
                  <button class="btn btn-primary btn-sisp" id="btnLimparFiltros" style="background-color: #B22222; border-color: #B22222"><span class="fas fa-trash"></span> Limpar
                    Filtros</button>     
                  <button class="btn btn-primary btn-sisp" id="btnConsultar"><span class="fas fa-search"></span>
                    Consultar</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <?php
  include_once('../../../footer.php');
  include_once('../../../modals/modal_anexos.html');
  ?>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <script src="plugins/jquery/jquery.min.js?versao=3.232.3.1"></script>
  <script type="text/javascript" src="dist/js/jquery.dataTables.js?versao=3.232.3.1"></script>
  <script type="text/javascript" src="dist/js/dataTables.bootstrap4.min.js?versao=3.232.3.1"></script>
  <script src="plugins/jquery-ui/jquery-ui.min.js?versao=3.232.3.1"></script>
  <script>
    $.widget.bridge('uibutton', $.ui.button);
  </script>
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js?versao=3.232.3.1"></script>
  <script src="dist/js/adminlte.min.js?versao=3.232.3.1"></script>
  <script src="dist/js/sisplan.js?versao=3.232.3.1"></script>
  <script src="plugins/toastr/toastr.min.js?versao=3.232.3.1"></script>
  <script src="utils/cookies.js?versao=3.232.3.1"></script>
  <script src="utils/funcoes.js?versao=3.232.3.1"></script>
  <script src="dist/js/requisicoes.js?versao=3.232.3.1"></script>
  <script src="dist/js/loadingoverlay.min.js?versao=3.232.3.1"></script>
  <script src="dist/js/driver.min.js?versao=3.232.3.1"></script>
  <script src="plugins/moment/moment.min.js?versao=3.232.3.1"></script>
  <script type="text/javascript" src="dist/js/sum().js?versao=3.232.3.1"></script>
  <script type="text/javascript" src="config.js?versao=3.232.3.1"></script>
  <script type="text/javascript" src="modals/modal_anexos.js?versao=3.232.3.1"></script>
  <script>
    $(document).ready(async function() {
      if (getCookie('usuario') == "") {
        window.location.href = `${BASE_URI}/login`;
        return;
      }

      let usuario = getCookie('usuario');
      let empresa = getCookie('empresa');

      ipInterno = IP_INTERNO;
      basicAuth = BASIC_AUTH;

      const temAcesso = await temAcessoTela('RAMOATUACAO');
      if (!temAcesso.resultado) {
        toastrAcesso(temAcesso, BASE_URI);
        return;
      }

      sArquivo = `${BASE_URI}/pages/ramoatuacao/acesso_ramoatuacao/acesso_ramoatuacao.js?versao=3.232.3.1`;
      insereJavaScriptPagina(sArquivo);

    });
  </script>
</body>

</html>