$(document).ready(async function () {

  preencheOrdenacaoTela('RelComissao');


  const Troca = $("#cbTrazerTroca").is(':checked', true) ? 1 : 0;
  if (Troca != 1) {
    $("#tabTroca").addClass('d-none')
  }

  manipulaTabTroca()

  $("#divTroca").addClass('d-none')

  $('#tabTroca').on('click', async function () {
    $('#divTroca').removeClass('d-none')
    $('#divComissao').addClass('d-none')
  })

  $('#tabComissao').on('click', async function () {
    $('#divTroca').addClass('d-none')
    $('#divComissao').removeClass('d-none')
  })

  $('#btnSelecionarEmpresas').on('click', function () {
    carregaEmpresasDisponiveis();
  });

  //Quantidade de linhas das tabelas referente ao tamanho da tela
  const qtdeLinhasTabela = ((screen.width == 1366) && (screen.height == 768)) ? 7 : 17;

  // autocompleta
  $("#txtVendedor").autocompleta(1, `JSON={ "tabela":"REPRESEN", "camposSelect":[ "CODREP CHAVE", "NOME DESCRICAO"], "where": null}`);
  $('#txtGuia').autocompleta(1, `JSON={ "tabela": "REPRESEN", "camposSelect": ["CODREP CHAVE", "NOME DESCRICAO"], "where": ["REPRESEN.ATIVO = 'S'", "REPRESEN.GRUPO_REP = 'U'"]}`);
  $("#txtIndicador").autocompleta(1, `JSON={ "tabela":"REPRESEN", "camposSelect":[ "CODREP CHAVE", "NOME DESCRICAO"], "where": null}`);
  $("#txtMoeda").pesquisa_variosServerside(1, `{ "tabela":"MOEDA", "camposSelect":[ "CODMOE", "DESCRICAO"], "where": null}`, 'CODMOE', 'DESCRICAO');
  $('#txtTabela').autocompleta(1, `JSON={ "tabela": "REGIAO", "camposSelect": ["REGIAO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
  $("#txtCoordenador").autocompleta(1, `JSON={ "tabela":"REPRESEN", "camposSelect":[ "CODREP CHAVE", "NOME DESCRICAO"], "where": null}`);

  //pesquisa serverside
  $("#btnVendedor").pesquisa_serverside(['#txtVendedor'], ["CODREP"], ["NOME"], `{"tabela":"REPRESEN", "camposSelect":["CODREP", "NOME"]}`, 'Pesquisa Vendedor');
  $("#btnGuia").pesquisa_serverside(['#txtGuia'], ["CODREP"], ["NOME"], `{"tabela":"REPRESEN", "camposSelect":["CODREP", "NOME"], "where": ["ATIVO = 'S'", "GRUPO_REP = 'U'"]}`, 'Pesquisa Guia');
  $("#btnIndicador").pesquisa_serverside(['#txtIndicador'], ["CODREP"], ["NOME"], `{"tabela":"REPRESEN", "camposSelect":["CODREP", "NOME"]}`, 'Pesquisa Indicador');
  $("#btnMoeda").pesquisa_serversideSel('#txtMoeda', `{"tabela":"MOEDA", "camposSelect":["CODMOE", "DESCRICAO"]}`, 'Pesquisa Moeda');
  $("#btnTabela").pesquisa_serverside(['#txtTabela'], ["REGIAO"], ["DESCRICAO"], `{"tabela":"REGIAO", "camposSelect":["REGIAO", "DESCRICAO"]}`, 'Pesquisa Tabela');
  $("#btnCoordenador").pesquisa_serverside(['#txtCoordenador'], ["CODREP"], ["NOME"], `{"tabela":"REPRESEN", "camposSelect":["CODREP", "NOME"]}`, 'Pesquisa Coordenador');

  //Fazer a limpeza dos campos
  $("#btnLimpaVendedor").on("click", function () {
    $("#txtVendedor").val("");
  });

  $("#btnLimpaGuia").on("click", function () {
    $("#txtGuia").val("");
  });

  $("#btnLimpaIndicador").on("click", function () {
    $("#txtIndicador").val("");
  });

  $("#btnLimpaMoeda").on("click", function () {
    $('#txtMoeda').empty().trigger('change');
  });

  $("#btnLimpaTabela").on("click", function () {
    $("#txtTabela").val("");
  });

  $("#btnLimpaCoordenador").on("click", function () {
    $("#txtCoordenador").val("");
  });

  $('#btnLimparFiltros').on('click', async function () {
    $("#txtVendedor").val("");
    $("#txtGuia").val("");
    $("#txtIndicador").val("");
    $('#txtMoeda').empty().trigger('change');
    $("#txtTabela").val("");
    $("#txtCoordenador").val("");
    $('#radioOperTodos').prop('checked', true);
    $('#cbSeparaComissao').prop('checked', false);
    $('#cbLancamentosManuais').prop('checked', false);
    $('#cbValZerado').prop('checked', false);
    $('#cbTrazerTroca').prop('checked', false);
    $('#dtInicioDe').val('1200-01-01')
    $('#dtInicioAte').val('2500-12-31')
    $('#dtVencimentoDe').val('1200-01-01')
    $('#dtVencimentoAte').val('2500-12-31')
  });

  //Modais
  $("#btnFiltros").on("click", async function () {
    $("#modal-filtros").modal("show");
  });

  $("#btnImprimir").on("click", async function () {
    try {
      $.LoadingOverlay("show");
      try {
        const ordem = `&TELA_ORDENACAO=RelComissao&ORDEM_ORDENACAO=${$('#txtOrdem').val()}`;
        const url = `/sisplan/impressao/v1/imprimirrelcomissao?`;
        const Filtros = await preencheFiltros();
        const bImprimeAutomatico = await verificaImprimirAutomatico('RelComissao');
        const arquivo = await GeraRelatorio(`${url}${Filtros}${ordem}`, "GET", 100000, false, 'RelComissao');

        if (arquivo != undefined) {
          if (!bImprimeAutomatico) {
            window.open(`${BASE_URI}/relatorios_api/pdf/${arquivo}`, "_blank");
          }
          await limparRelatorios();
        }
      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay("hide");
    }
  });

  async function preencheFiltros() {
    let radioOper = ''
    try {
      //Inputs
      const sDtInicioDe = $("#dtInicioDe").val();
      const sDtInicioAte = $("#dtInicioAte").val();
      const sDtVencimentoDe = $("#dtVencimentoDe").val();
      const sDtVencimentoAte = $("#dtVencimentoAte").val();
      const sVendedor = pegaChave("#txtVendedor");
      const sGuia = pegaChave("#txtGuia");
      const sIndicador = pegaChave("#txtIndicador");
      const sMoeda = await formataListas($('#txtMoeda').val().toString());
      const consMoeda = $("#cbConsiderarMoeda").is(':checked', true) ? 'S' : 'N';
      const sTabela = pegaChave("#txtTabela");
      const sCoordenador = $("#txtCoordenador").val();
      //CheckBox
      const sSeparaComissao = $("#cbSeparaComissao").is(':checked', true) ? 1 : 0;
      const sValZerado = $("#cbValZerado").is(':checked', true) ? 1 : 0;
      const sTrazerTroca = $("#cbTrazerTroca").is(':checked', true) ? 1 : 0;
      const listaEmpIds = $('.empresa_selecionada:checked').toArray().length > 0 ? $('.empresa_selecionada:checked').toArray().map(input => input.id.substring(input.id.indexOf('-') + 1, input.id.length))
        : [getCookie('emp_id')];
      //RadioButton
      if ($('#radioOperSim').is(':checked')) {
        radioOper = 1
      }
      if ($('#radioOperNao').is(':checked')) {
        radioOper = 0
      }
      const retorno =
        `VENDEDOR=${sVendedor}` +
        `&GUIA=${sGuia}` +
        `&INDICADOR=${sIndicador}` +
        `&MOEDA=${sMoeda}` +
        `&CONSMOEDA=${consMoeda}` + 
        `&TABELA=${sTabela}` +
        `&COORDENADOR=${sCoordenador}` +
        `&DTINICIODE=${sDtInicioDe}` +
        `&DTINICIOATE=${sDtInicioAte}` +
        `&DTVENCIMENTODE=${sDtVencimentoDe}` +
        `&DTVENCIMENTOATE=${sDtVencimentoAte}` +
        `&SEPARA_COMISSAO=${sSeparaComissao}` +
        `&VALOR_ZERADO=${sValZerado}` +
        `&TRAZER_TROCA=${sTrazerTroca}` +
        `&EMP_IDS=${listaEmpIds}` +
        `&OPER_FISCAL=${radioOper}`;

      return retorno;

    } catch (error) {
      console.error(error);
      $.LoadingOverlay("hide");
    }
  }

  async function limpaTabela() {
    $('#tabelaComissao').DataTable().destroy().draw(false);
    $('#tabelaComissao').html('<thead></thead><tbody></tbody>');
  }

  async function buscaTabelaComissao() {
    if ($('#tabelaComissao')[0].rows.length > 0) {
      await limpaTabela();
    }
    $('#divTabelaComissao').removeClass('d-none')
    if ($.fn.DataTable.isDataTable('#tabelaComissao')) {
      $('#tabelaComissao').DataTable().destroy();
      $('#tabelaComissao').empty();
    };

    try {
      let dataSetCols = [];
      const ordemOrdenacao = $('#txtOrdem').val();
      const url = `/sisplan/impressao/v1/consultarelcomissao?ordem_ordenacao=${ordemOrdenacao}&`;
      const Filtros = await preencheFiltros();
      const response = await requisicao("GET", url, Filtros, '', 30000);

      if (!response) {
        return;
      }

      const jsonStr = await response.json();

      if (jsonStr.length == 0) {
        msgAlerta("Nenhum registro encontrado!");
        $("#txtVendedor").val();
        $("#txtGuia").val();
        $("#txtIndicador").val();
        $("#txtMoeda").val();
        $("#txtTabela").val();
        $("#txtCoordenador").val();
        return;
      }

      if (response.status != 200) {
        console.error(jsonStr.mensagem);
        return;
      }

      let keys = Object.keys(jsonStr[0]);

      keys.forEach((k) => {
        dataSetCols.push({
          title: k,
          data: k,
        });
      });

      let indiceValor;

      for (let i = 0; i < keys.length; i++) {
        if (keys[i] == 'VALOR') {
          indiceValor = i;
        }
      }

      $("#tabelaComissao").DataTable({
        destroy: true,
        filter: false,
        info: false,
        order: false,
        "pageLength": qtdeLinhasTabela,

        language: {
          sEmptyTable: "Nenhum registro encontrado",
          sInfo: "_TOTAL_ registros",
          sInfoEmpty: " 0 registros",
          sInfoFiltered: "(Filtrados de _MAX_ registros)",
          sInfoPostFix: "",
          sInfoThousands: ".",
          sLengthMenu: "_MENU_ resultados",
          sLoadingRecords: "Carregando...",
          sProcessing: "Processando...",
          sZeroRecords: "Nenhum registro encontrado",
          sSearch: "Pesquisar",
          oPaginate: {
            sNext: "Próximo",
            sPrevious: "Anterior",
            sFirst: "Primeiro",
            sLast: "Último",
          },
          oAria: {
            sSortAscending: ": Ordenar colunas de forma ascendente",
            sSortDescending: ": Ordenar colunas de forma descendente",
          },
        },
        autoWidth: true,
        data: jsonStr,
        columns: dataSetCols,
        "columnDefs": [{
        },
        {
          "render": function (data) {
            return parseFloat(data).toLocaleString('pt-br', {
              style: 'currency',
              currency: 'BRL'
            });
          },
          "targets": +indiceValor
        },
        {
          render(data) {
            return parseFloat(data).toLocaleString("pt-BR", {
              maximumFractionDigits: 2,
              minimumFractionDigits: 2
            });
          },
          targets: [10, 12, 14, 16, 50],
        },
        ],
      });
    } catch (error) {
      console.log(error)
    }
    finally {
      $.LoadingOverlay('hide')
    }
  }

  $('#tabTroca').on('click', async function () {
    buscaTabelaTroca();
  });

  async function buscaTabelaTroca() {
    $('#tabTroca').removeClass('d-none');
    $('#divTabelaTroca').removeClass('d-none');
    if ($.fn.DataTable.isDataTable('#tabelaTroca')) {
      $('#tabelaTroca').DataTable().destroy();
      $('#tabelaTroca').empty();
    };
    try {
      let dataSetCols = [];
      const ordemOrdenacao = $('#txtOrdem').val();
      const url = `/sisplan/impressao/v1/consultarelcomissaotrocas?ordem_ordenacao=${ordemOrdenacao}&`;
      const Filtros = await preencheFiltros();
      const response = await requisicao("GET", url, Filtros, '', 30000);

      if (!response) {
        return;
      }

      const jsonStr = await response.json();

      if (response.status != 200) {
        console.error(jsonStr.mensagem);
        return;
      }

      let keys = Object.keys(jsonStr[0]);

      keys.forEach((k) => {
        dataSetCols.push({
          title: k,
          data: k,
        });
      });

      let indiceValor;

      for (let i = 0; i < keys.length; i++) {
        if (keys[i] == 'VALOR') {
          indiceValor = i;
        }
      }

      $("#tabelaTroca").DataTable({
        destroy: true,
        filter: false,
        info: false,
        order: false,
        "pageLength": qtdeLinhasTabela,
        language: {
          sEmptyTable: "Nenhum registro encontrado",
          sInfo: "_TOTAL_ registros",
          sInfoEmpty: " 0 registros",
          sInfoFiltered: "(Filtrados de _MAX_ registros)",
          sInfoPostFix: "",
          sInfoThousands: ".",
          sLengthMenu: "_MENU_ resultados",
          sLoadingRecords: "Carregando...",
          sProcessing: "Processando...",
          sZeroRecords: "Nenhum registro encontrado",
          sSearch: "Pesquisar",
          oPaginate: {
            sNext: "Próximo",
            sPrevious: "Anterior",
            sFirst: "Primeiro",
            sLast: "Último",
          },
          oAria: {
            sSortAscending: ": Ordenar colunas de forma ascendente",
            sSortDescending: ": Ordenar colunas de forma descendente",
          },
        },
        autoWidth: true,
        data: jsonStr,
        columns: dataSetCols,
        "columnDefs": [{
        },
        {
          "render": function (data) {
            return parseFloat(data).toLocaleString('pt-br', {
              style: 'currency',
              currency: 'BRL'
            });
          },
          "targets": +indiceValor
        },
        {
          render(data) {
            return parseFloat(data).toLocaleString("pt-BR", {
              maximumFractionDigits: 2,
              minimumFractionDigits: 2
            });
          },
          targets: [35],
        },
        ],
      });
    } catch (error) {
      console.log(error)
    }
    finally {
      $.LoadingOverlay('hide')
    }
  }

  $("#btnConsultar").on("click", async function () {
    try {
      $.LoadingOverlay("show");
      try {
        await buscaTabelaComissao();

        const Troca = $("#cbTrazerTroca").is(':checked', true) ? 1 : 0;
        if (Troca == 1) {
          await buscaTabelaTroca();
        }

      } catch (error) {
        console.error(error);
      }

    } finally {
      $.LoadingOverlay("hide");
      $("#modal-filtros").modal("hide");
    }
  });

  function manipulaTabTroca() {
    if (Troca == 1) {
      $('#tabTroca').removeClass('d-none')
    } else if (Troca == 0) {
      $('#tabTroca').addClass('d-none')
    }
  }

});
