<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Sisplan Web | Relatório de Embarque</title>
    <!-- Tell the browser to be responsive to screen width -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=2.5.4">

    <link rel="stylesheet" href="dist/css/adminlte.min.css?versao=2.5.4">
    <link rel="stylesheet" href="dist/css/custom.css?versao=2.5.4">
    <link rel="stylesheet" href="dist/css/sisplan.css?versao=2.5.4">
    <link rel="stylesheet" type="text/css" href="plugins/datatables-keytable/css/keyTable.bootstrap4.min.css?versao=2.5.4">
    <link rel="stylesheet" href="plugins/toastr/toastr.min.css?versao=2.5.4">
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=2.5.4">
    <link rel="shortcut icon" href="favicon.ico">
    <link rel="stylesheet" type="text/css" href="dist/css/driver.min.css?versao=2.5.4" />
    <link rel="stylesheet" href="dist/css/jquery-ui.css?versao=2.5.4">
    <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css?versao=3.227.20.1">
    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="dist/css/bootstrap-tagsinput.css?versao=3.232.21.1">
</head>

<style>
    .border-Field .textoBorda {
        font-size: 1.1em !important;
        text-align: left !important;
        width: auto;
        padding: 0 10px;
        border-bottom: none;
    }

    .border-Field {
        border: 1px solid var(--white-dark) !important;
        /* padding: 0 1.0em 1.0em 1.0em !important; */
        margin: 0 0 1.0em 0 !important;
        -webkit-box-shadow: 0px 0px 0px 0px #000;
        box-shadow: 0px 0px 0px 0px #000;
    }

    #tabelaRelEmbarque_length {
        display: none;
    }

    #tabelaRelEmbarque_filter {
        display: none;
    }

    #tabelaRelEmbarque_info {
        display: none;
    }

    .table.dataTable tbody td {
        white-space: nowrap;
        text-overflow: ellipsis;
        overflow: hidden;
    }
</style>

<body class="hold-transition sidebar-mini layout-fixed">
    <main class="wrapper">

        <?php
        include_once('../../menu.php');
        ?>

        <div class="content-wrapper">
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6 flex">
                            <h1 class="m-0 text-dark">Relatório de Embarque</h1>
                            <button type="button" class="btn btn-info btn-sm ml-2" title="Tutorial" style="color: white;" id="tutorial">
                                <i class="fas fa-question-circle"></i></button>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="./index">Início</a></li>
                                <li class="breadcrumb-item active">Relatório de Embarque</li>
                            </ol>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <fieldset>
                                <div class="row">
                                    <div class="col-12">
                                        <div class="buttons">
                                            <button class="btn btn-success btn-sisp" id="btnFiltros" type="button"><span class="fas fa-filter"></span> Filtros</button>
                                            <button id="btnImprimir" class="btn-sisp btn btn-danger"><i class="fas fa-print"></i> Imprimir</button>
                                            <button id="btnEmail" style="position: absolute; left: 252px;" class="btn-sisp btn btn-primary"><i class="fas fa-envelope pr-1"></i> E-mail XML</button>
                                        </div>
                                    </div>
                                </div>
                                <div class="card-body">
                                    <div class="card">
                                        <div class="col-sm-12 table-responsive card-body">
                                            <table id="tabelaRelEmbarque" class="table table-sm table-select table-hover" width="100%"></table>
                                            <thead>
                                            </thead>
                                            <tbody>
                                            </tbody>
                                        </div>
                                    </div>
                                </div>
                            </fieldset>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div id="modal-filtros" class="modal" tabindex="-1" role="dialog">
            <div class="modal-dialog modal-xl" role="document">
                <div class="modal-content" id="modalBody">
                    <div class="modal-header">
                        <h4 class="modal-title">Filtros
                        </h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="row">


                            <div class="col-md-3 col-3 form">
                                <fieldset class="form border-Field p-0">
                                    <legend class="textoBorda pb-0 mb-0">Tipo</legend>
                                    <div class="form-row ml-3">
                                        <label class="labelCheck"><input type="radio" checked="checked" id="radioEtiqueta" name="tipo"><span class="checkmark"></span>  Etiqueta</label>
                                        <label class="labelCheck ml-3"><input type="radio" id="radioMinuta" name="tipo"><span class="checkmark"></span>  Minuta</label>
                                    </div>
                                </fieldset>
                            </div>

                            <div class="col-md-9 col-9 form">
                                <fieldset class="form border-Field p-0">
                                    <legend class="textoBorda pb-0 mb-0">Opções</legend>
                                    <div class="form-row ml-3">
                                        <label class="labelCheck" for="cbTodasEmpresas">   <input type="checkbox" class="configCheck" id="cbTodasEmpresas">  Todas Empresas </label>
                                        <label class="labelCheck" for="cbNotasDenegadas">   <input type="checkbox" class="configCheck" id="cbNotasDenegadas">  Notas Denegadas </label>
                                        <label class="labelCheck" for="cbTipoNatVendas">   <input type="checkbox" class="configCheck" id="cbTipoNatVendas">  Tipo Natureza Vendas </label>
                                        <label class="labelCheck" for="cbSemDtEmbarque">   <input type="checkbox" class="configCheck" id="cbSemDtEmbarque">  Sem Data Embarque </label>
                                        <label class="labelCheck d-none" for="cbExpedicao">   <input type="checkbox" class="configCheck" id="cbExpedicao">  Expedição </label>
                                        <label class="labelCheck d-none" for="cbEmbalagem">   <input type="checkbox" class="configCheck" id="cbEmbalagem">  Embalagem </label>
                                        <label class="labelCheck d-none" for="cbImpressoraTermica">   <input type="checkbox" class="configCheck" id="cbImpressoraTermica">  Impressão Térmica </label>
                                    </div>
                                </fieldset>
                            </div>


                            <div class="col-4 col-md-4">
                                <label data-error="wrong" data-success="right" for="txtDtEmissaoDe">Emissao De/ Até:</label>
                                <div class="input-group">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="1200-01-01" class="input-default focus form-control" id="txtDtEmissaoDe" class="form-control">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="2500-12-31" class="input-default focus form-control" id="txtDtEmissaoAte" class="form-control">
                                </div>
                            </div>


                            <div class="col-4 col-md-4">
                                <label data-error="wrong" data-success="right" for="txtDtSaidaDe">Saída De/ Até:</label>
                                <div class="input-group">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="1200-01-01" class="input-default focus form-control" id="txtDtSaidaDe" class="form-control">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="2500-12-31" class="input-default focus form-control" id="txtDtSaidaAte" class="form-control">
                                </div>
                            </div>

                            <div class="col-4 col-md-4">
                                <label data-error="wrong" data-success="right" for="txtDtEmbarqueDe">Embarque De/ Até:</label>
                                <div class="input-group">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="1200-01-01" class="input-default focus form-control" id="txtDtEmbarqueDe" class="form-control">
                                    <input type="date" max="2500-12-31" autocomplete="off" value="2500-12-31" class="input-default focus form-control" id="txtDtEmbarqueAte" class="form-control">
                                </div>
                            </div>

                            <div class="col-md-12 col-sm-12 col-12">
                                <label style="margin-bottom: .1rem;" data-error="wrong" class="labelGearal" data-success="right" for="txtOrdem">Ordem Impressão</label>
                                <div class="input-group">
                                    <select class="input-default focus form-control" data-dropdown-css-class="select2-danger" id="txtOrdem" class="custom-select">
                                    </select>
                                </div>
                            </div>

                            <div class="col-md-6 col-sm-12 col-6">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" id="labelTransportadora" for="txtTransportadora">Transportadora: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtTransportadora" class="form-control" placeholder="Transportadora">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnTransportadora" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaTransportadora" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-6 col-sm-12 col-6">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtNotas">Lista Notas: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtNotas" class="form-control" placeholder="Notas">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnNotas" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaNotas" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" id="labelTipoCliente" for="txtTipoCliente">Tipo Cliente: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtTipoCliente" class="form-control" placeholder="Tipo Cliente">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnTipoCliente" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaTipoCliente" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" id="labelRepresentante" for="txtRepresentante">Representante: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtRepresentante" class="form-control" placeholder="Representante">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnRepresentante" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaRepresentante" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" id="labelCliente" for="txtCliente">Cliente: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtCliente" class="form-control" placeholder="Cliente">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnCliente" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaCliente" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtUF">UF: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtUF" class="form-control" placeholder="UF">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnUF" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaUF" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtOperFiscal">Operação Fiscal: </label>
                                <div class="relative" style="margin-top: 5px;">
                                    <div class="input-group">
                                        <input type="text" class="input-default focus form-control" id="txtOperFiscal" class="form-control" placeholder="Operação Fiscal">
                                        <div class="input-group-append">
                                            <button class="btn bg-danger" id="btnOperFiscal" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                                            <button class="btn bg-danger" id="btnLimpaOperFiscal" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 col-sm-12 col-4">
                                <label data-error="wrong" data-success="right" for="selectTipoNatureza">Tipo Natureza</label>
                                <select style="width:100%;" class="form-control select2 select2-danger focus" data-dropdown-css-class="select2-danger" id="selectTipoNatureza" aria-invalid="false">
                                    <option value="">Todas</option>
                                    <option value="1">1 - Saída</option>
                                    <option value="2">2 - Entrada</option>
                                </select>
                            </div>

                        </div>
                    </div>
                    <div class="modal-footer">
                        <div class="row">
                            <button class="btn btn-primary btn-sisp" id="btnLimparFiltros" style="background-color: #B22222; border-color: #B22222; margin-right: 15px;"><span class="fas fa-trash"></span> Limpar Filtros</button>
                            <button id="btnConsultar" class='btn btn-primary btn-sisp' type='button'><span class="fas fa-search"></span> Consultar </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Control Sidebar -->
        <aside class="control-sidebar control-sidebar-dark">
            <!-- Control sidebar content goes here -->
        </aside><!-- /.control-sidebar -->
        <?php include_once('../../footer.php'); ?>
    </main><!-- /.wrapper -->


    <script src="plugins/jquery/jquery.min.js?versao=2.5.4"></script>
    <script src="dist/js/jquery.maskMoney.min.js?versao=2.5.4"></script>
    <script src="plugins/jquery-ui/jquery-ui.min.js?versao=2.5.4"></script>
    <script type="text/javascript" src="dist/js/jquery.dataTables.js?versao=2.5.4"></script>
    <script type="text/javascript" src="dist/js/dataTables.bootstrap4.min.js?versao=2.5.4"></script>
    <script src="plugins/sweetalert2/sweetalert2.min.js?versao=2.5.4"></script>
    <script src="plugins/toastr/toastr.min.js?versao=2.5.4"></script>
    <script>
        $.widget.bridge('uibutton', $.ui.button);
    </script>
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js?versao=2.5.4"></script>
    <script src="dist/js/adminlte.min.js?versao=2.5.4"></script>
    <script src="dist/js/requisicoes.js?versao=2.5.4"></script>
    <script src="dist/js/loadingoverlay.min.js?versao=2.5.4"></script>
    <script src="dist/js/valida_cpf_cnpj.js?versao=2.5.4"></script>
    <script src="plugins/jquery-validation/jquery.validate.min.js?versao=2.5.4"></script>
    <script src="dist/js/dataTables.keyTable.js?versao=2.5.4"></script>
    <script src="dist/js/sisplan.js?versao=2.5.4"></script>
    <script src="utils/funcoes.js?versao=2.5.4"></script>
    <script src="utils/cookies.js?versao=2.5.4"></script>
    <script src="dist/js/driver.min.js?versao=2.5.4"></script>
    <script src="config.js?versao=2.5.4"></script>
    <script src="dist/js/popper.min.js?versao=3.232.21.1"></script>
    <script src="dist/js/tippy-bundle.umd.js?versao=3.232.21.1"></script>

    <script src="dist/js/bootstrap-tagsinput.min.js?versao=3.232.21.1"></script>
    <script>
        $(document).ready(async function() {
            if (getCookie('usuario') == "") {
                window.location.href = `${BASE_URI}/login`;
                return;
            }

            let usuario = getCookie('usuario');
            let empresa = getCookie('empresa');

            ipInterno = IP_INTERNO;
            ipExterno = IP_EXTERNO;
            basicAuth = BASIC_AUTH;

            const temAcesso = await temAcessoTela('RELEMBARQUE');
            if (!temAcesso.resultado) {
                toastrAcesso(temAcesso, BASE_URI);
                return;
            }

            sArquivo = `${BASE_URI}/pages/relembarque/relembarque.js?versao=2.5.4`;
            const nomeTela = ('<?php echo basename(__FILE__) ?>').replace('.php', '');
            // nomeTela


            await insereJavaScriptPagina(sArquivo);

            habilitaCamposObrigatoriosTela(nomeTela);
        });
    </script>

</body>

</html>