$(document).ready(async function () {
    $('#tutorial').on('click', function () {
        $(document).ready(async function () {
            const driver = new Driver({
                doneBtnText: 'Sair',
                closeBtnText: 'Fechar',
                nextBtnText: 'Próximo',
                prevBtnText: 'Anterior',
                allowClose: false
            });
            driver.defineSteps([{
                element: '#btnFiltros',
                popover: {
                    title: 'Botão Filtros',
                    description: 'Clique aqui para abrir os filtros e realizar alguma consulta.',
                    position: 'right'
                }
            },
            {
                element: '#btnImprimir',
                popover: {
                    title: 'Botão Imprimir',
                    description: 'Clique aqui para Imprimir um relatório.',
                    position: 'right'
                }
            }
            ]);
            driver.start();
        });
    });

    preencheOrdenacaoTela('RelEstoqueMat');

    const filtroDeposito = await retornaDepositoUsuario();

    async function retornaDepositoUsuario() {
        try {
            $.LoadingOverlay("show");
            try {
                const url = '/Sisplan/Funcoes/v1/pesquisa?';
                const params = `JSON={ "tabela":"ACESSO_USUARIOS", "camposSelect":["DEPOSITOS"], "where": ["CODIGO = ${getCookie('cod_usuario')}"]}`;
                const response = await requisicao('GET', url, params, null);

                if (!response) {
                    return 'null';
                }

                const jsonStr = await response.json();

                if (jsonStr.codigo == 400) {
                    return 'null';
                }
                const result = jsonStr.RESULT[0][0].DEPOSITOS != '' ? `["CODIGO IN (${jsonStr.RESULT[0][0].DEPOSITOS})"]` : 'null';
                return result;
            } catch (error) {
                console.error(error);
                return 'null';
            }
        } finally {
            $.LoadingOverlay("hide");
        }
    }




    $('#txtCodigo').autocompleta(3, `JSON={ "tabela":"MATERIAL", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    $('#txtColecao').autocompleta(1, `JSON={ "tabela":"COLECAO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    $('#txtDeposito').autocompleta(1, `JSON={ "tabela":"DEPOSITO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": ${filtroDeposito}}`);
    $('#txtCor').autocompleta(1, `JSON={ "tabela":"CADCOR", "camposSelect":[ "COR CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    $('#txtGrupo').autocompleta(1, `JSON={ "tabela":"GRUPO_PA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    $('#txtQualidade').autocompleta(1, `JSON={ "tabela":"TABQUL", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    $('#txtSubgrupo').autocompleta(1, `JSON={ "tabela":"SUBGRUPO_MA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}`);
    // $('#btn-Codigo').pesquisa_array(['#txtCodigo'], ['CODIGO'], ['DESCRICAO', 'PA_ITEN.BARRA28'], `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"PRODUTO", "camposSelect":[ "PRODUTO.CODIGO", "PRODUTO.DESCRICAO", "PA_ITEN.BARRA28"],  "leftJoin": [{"tabela": "PA_ITEN", "CONDICAO": "PA_ITEN.CODIGO = PRODUTO.CODIGO"}]}`, 'Pesquisa Produto', 'PRODUTO');

    $('#btn-Codigo').pesquisa_serverside(['#txtCodigo'], ['MATERIAL.CODIGO'], ['MATERIAL.DESCRICAO'], '{ "tabela":"MATERIAL", "camposSelect":[ "MATERIAL.CODIGO", "MATERIAL.DESCRICAO"]}', 'Pesquisa de Material');
    $('#btn-Colecao').pesquisa('#txtColecao', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"COLECAO", "camposSelect":[ "CODIGO", "DESCRICAO"]}`, 'Pesquisa Coleção', 'COLECAO');
    $('#btn-Deposito').pesquisa('#txtDeposito', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"DEPOSITO", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": ${filtroDeposito}}`, 'Pesquisa Depósito', 'DEPOSITO');
    $('#btn-Cor').pesquisa('#txtCor', 'COR', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"CADCOR", "camposSelect":[ "COR", "DESCRICAO"]}`, 'Pesquisa Cor', 'CADCOR');
    $('#btn-Grupo').pesquisa_array(['#txtGrupo'], ['CODIGO'], ['DESCRICAO'], `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"GRUPO_MA", "camposSelect":[ "CODIGO", "DESCRICAO"]}`, 'Pesquisa Grupo de Material', 'GRUPO_MA');
    $('#btn-Qualidade').pesquisa('#txtQualidade', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"TABQUL", "camposSelect":[ "CODIGO", "DESCRICAO"]}`, 'Pesquisa Qualidade', 'TABQUL');
    $('#btnSubgrupo').pesquisa('#txtSubgrupo', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"SUBGRUPO_MA", "camposSelect":[ "CODIGO", "DESCRICAO"]}`, 'Pesquisa de SubGrupo de Material', 'SUBGRUPO_MA');

    $('#txtDeposito').listaFiltros();
    // await carregaValoresPadroes();


    $('#btn-limpa-Codigo').on('click', function () {
        $('#txtCodigo').val('');
    });

    $('#btn-limpa-Colecao').on('click', function () {
        $('#txtColecao').val('');
    });

    $('#btn-limpa-Deposito').on('click', function () {
        if ($('#txtDeposito').val() == '') {
            $('#listaDeposito').val('');
        }
        $('#txtDeposito').val('');
        $('#txtDeposito').focus();
    });

    $('#btn-limpa-Cor').on('click', function () {
        $('#txtCor').val('');
    });

    $('#btn-limpa-Grupo').on('click', function () {
        $('#txtGrupo').val('');
    });

    $('#btn-limpa-Qualidade').on('click', function () {
        $('#txtQualidade').val('');
    });

    $('#btnLimpaSubgrupo').on('click', function () {
        $('#txtSubgrupo').val('');
    })

    $('#btnFiltros').on('click', async function () {
        $('#modal-filtros').modal('show');
    });

    // async function carregaValoresPadroes() {
    //     const pesquisa = {
    //         camposSelect: ['CAMPO', 'VALOR'],
    //         tabela: 'TABPADRAO',
    //         where: [`TABELA = 'ESTOQUE'`]
    //     }
    //     const jsonStr = await retornaJsonPesquisaPadrao(JSON.stringify(pesquisa));

    //     jsonStr.map(item => {
    //         switch (item.CAMPO) {
    //             case 'DEPOSITO': {
    //                 if (item.VALOR != '') {
    //                     insereValor('#txtDeposito', item.VALOR, 'VALOR PADRÃO');
    //                     var e = jQuery.Event("keypress");
    //                     e.which = 13;
    //                     $('#txtDeposito').trigger(e);
    //                     $('#listaDeposito').removeClass('d-none');
    //                 }
    //                 break;
    //             }
    //             case 'QUALIDADE': {
    //                 if (item.VALOR != '') {
    //                     insereValor('#txtQualidade', item.VALOR, 'VALOR PADRÃO');
    //                 }
    //                 break;
    //             }
    //         }
    //     });
    // };



    async function retornaFiltros() {

        const tipoItem = 'M';
        const codigo = pegaChave('#txtCodigo');
        let deposito = await formataListas($('#listaDeposito').val());
        const cor = pegaChave('#txtCor');
        const colecao = pegaChave('#txtColecao');
        const grupo = pegaChave('#txtGrupo');
        const qualidade = pegaChave('#txtQualidade');
        const contemEstoque = $('#cbContemEstoque').prop('checked');
        const subgrupo = pegaChave('#txtSubgrupo')
        deposito = deposito != ''
            ? deposito : filtroDeposito.replaceAll('["CODIGO IN (', '').replaceAll(')"]', '') != 'null'
                ? filtroDeposito.replaceAll('["CODIGO IN (', '').replaceAll(')"]', '')
                : '';
        const filtros = `CODIGO=${codigo}` +
            `&DEPOSITO=${deposito}` +
            `&COR=${cor}` +
            `&COLECAO=${colecao}` +
            `&GRUPO=${grupo}` +
            `&QUALIDADE=${qualidade}` +
            `&TIPOITEM=${tipoItem}` +
            `&CONTEMESTOQUE=${contemEstoque}` +
            `&SUBGRUPO=${subgrupo}`;

        return filtros;
    }


    $('#btnImprimir').on('click', async function () {
        try {
            $.LoadingOverlay('show');
            try {
                let url = `/sisplan/impressao/v1/estoque?`;

                const filtros = await retornaFiltros();
                const ordem = `&TELA_ORDENACAO=RelEstoqueMat&ORDEM_ORDENACAO=${$('#txtOrdem').val()}`;
                const bImprimeAutomatico = await verificaImprimirAutomatico('RelEstoqueMat');
                let arquivo = await GeraRelatorio(`${url}${filtros}${ordem}`, 'GET', 1000000, false, 'RelEstoqueMat');
                if (arquivo != undefined) {
                    if (!bImprimeAutomatico) {
                        window.open(`${BASE_URI}/relatorios_api/pdf/${arquivo}`, '_blank');
                    }
                    await limparRelatorios();
                }

            } catch (error) {
                console.error(error);
            }
        } finally {
            $.LoadingOverlay('hide');
        }
    });

    $('#btnConsultar').on('click', async function () {
        if ($.fn.DataTable.isDataTable('#tabelaRelEstoqueMat')) {
            $("#tabelaRelEstoqueMat").DataTable().destroy();
            $("#tabelaRelEstoqueMat").empty();
        }

        const sTipoItem = 'MATERIAL';
        const tabelaEstoque = 'MAT_ITEN';
        const campoQualidade = 'QUALIDADE';
        const sCodigo = pegaChave('#txtCodigo') != '' ? ` AND ${tabelaEstoque}.CODIGO = '${pegaChave('#txtCodigo')}'` : '';
        const sCor = pegaChave('#txtCor') != '' ? ` AND ${tabelaEstoque}.COR = '${pegaChave('#txtCor')}'` : '';
        const sColecao = pegaChave('#txtColecao') != '' ? ` AND COLECAO.CODIGO = '${pegaChave('#txtColecao')}'` : '';
        const sGrupo = pegaChave('#txtGrupo') != '' ? ` AND ${sTipoItem}.GRUPO = '${pegaChave('#txtGrupo')}'` : '';
        const sSubGrupo = pegaChave('#txtSubgrupo') != '' ? ` AND ${sTipoItem}.SUB_GRUPO = '${pegaChave('#txtSubgrupo')}'` : '';
        const sDeposito = $('#listaDeposito').val() != '' ?
            ` AND ${tabelaEstoque}.DEPOSITO IN (${await formataListas($('#listaDeposito').val())})`
            : filtroDeposito.replaceAll('["CODIGO IN (', '').replaceAll(')"]', '') != 'null'
                ? ` AND ${tabelaEstoque}.DEPOSITO IN (${filtroDeposito.replaceAll('["CODIGO IN (', '').replaceAll(')"]', '')})`
                : '';
        const ordemOrdenacao = $('#txtOrdem').val();
        let orderBy = await retornaOrderBy(ordemOrdenacao);
        let sQualidade = '';
        let somenteEstoque = '';

        sQualidade = pegaChave('#txtQualidade') != '' ? ` AND ${tabelaEstoque}.QUALIDADE = '${pegaChave('#txtQualidade')}'` : '';
        somenteEstoque = $('#cbContemEstoque').prop('checked') == true ? ` AND ${tabelaEstoque}.QTDE > 0 ` : '';


        let camposSelect = '';
        let colunas = [];
        let dataSetCols = [];

        try {
            try {
                $.LoadingOverlay("show");

                camposSelect = `["MAT_ITEN.ID_MAT_ITEN", "MAT_ITEN.CODIGO", "MATERIAL.DESCRICAO AS DESCRICAO", "MAT_ITEN.COR", "CADCOR.DESCRICAO DESCCOR", "COLECAO.CODIGO CODCOLECAO",
            "COLECAO.DESCRICAO DESCCOLECAO", "MAT_ITEN.DEPOSITO", "MAT_ITEN.LOTE", "MAT_ITEN.QTDE AS QUANTIDADE", "MAT_ITEN.BARRA", "0 AS TAM", "MATERIAL.UNIDADE","MATERIAL.SUB_GRUPO"]`
                colunas = ["ID_MAT_ITEN", "CODIGO", "DESCRICAO", "COR", "DESCCOR", "CODCOLECAO", "DESCCOLECAO", "DEPOSITO", "LOTE", "QUANTIDADE", "BARRA", "TAM", "UNIDADE", "SUB_GRUPO"];

                const ligacaoTabelaCor = `{"tabela": "CADCOR","condicao": "CADCOR.COR = ${tabelaEstoque}.COR"}`;

                const ligacaoProdutoMaterial = `{"tabela": "${sTipoItem}","condicao": "${sTipoItem}.CODIGO = ${tabelaEstoque}.CODIGO"}`;

                const ligacaoColecao = `{"tabela": "COLECAO","condicao": "COLECAO.CODIGO = ${sTipoItem}.COLECAO"}`;

                const ligacaoQualidade = `{"tabela": "TABQUL","condicao": "TABQUL.CODIGO = ${tabelaEstoque}.${campoQualidade}"}`;

                for (let i = 0; i < colunas.length; i++) {
                    dataSetCols.push({
                        'title': colunas[i],
                        'data': i
                    });
                }

                const ajaxData = {
                    "EMPRESA": getCookie('empresa'),
                    "JSON": `{"tabela":"${tabelaEstoque}", 
                      "camposSelect": ${camposSelect}, 
                      "leftJoin": [${ligacaoTabelaCor},${ligacaoProdutoMaterial},${ligacaoColecao},${ligacaoQualidade}], 
                      "where": ["1=1 ${sCodigo} ${sDeposito} ${sCor} ${sColecao} ${sGrupo} ${sQualidade} ${somenteEstoque} ${sSubGrupo}"],
                      "orderby": ["${orderBy}"]  
                    }`,
                    "CLIENTE": 'N',
                };

                $('#tabelaRelEstoqueMat').DataTable({
                    paging: true,
                    lengthChange: false,
                    filter: false,
                    info: true,
                    order: true,
                    autoWidth: true,
                    destroy: true,
                    serverSide: true,
                    processing: true,
                    ajax: {
                        url: `${getCookie('protocolo')}://${getCookie('ip_api')}/sisplan/funcoes/v1/pesquisadatatable`,
                        type: "GET",
                        headers: {
                            'Authorization': BASIC_AUTH
                        },
                        data: ajaxData,
                    },
                    "language": {
                        "sEmptyTable": "Nenhuma consulta realizada",
                        "sInfo": "_TOTAL_ registros",
                        "sInfoEmpty": " 0 registros",
                        "sInfoFiltered": "(Filtrados de _MAX_ registros)",
                        "sInfoPostFix": "",
                        "sInfoThousands": ".",
                        "sLengthMenu": "_MENU_ resultados",
                        "sLoadingRecords": "Carregando...",
                        "sProcessing": "Processando...",
                        "sZeroRecords": "Nenhuma consulta realizada",
                        "sSearch": "Pesquisar",
                        "oPaginate": {
                            "sNext": "Próximo",
                            "sPrevious": "Anterior",
                            "sFirst": "Primeiro",
                            "sLast": "Último"
                        },
                        "oAria": {
                            "sSortAscending": ": Ordenar colunas de forma ascendente",
                            "sSortDescending": ": Ordenar colunas de forma descendente"
                        }
                    },
                    columns: dataSetCols
                });
            } catch (error) {
                console.error(error);
                msgErro('Não foi possível buscar os dados dos itens.');
            }
        } finally {
            $.LoadingOverlay("hide");
            $('#modal-filtros').modal('hide');
        }
    });

    async function retornaOrderBy(ordem) {
        let resultado;
        const pesquisa = {
            tabela: "ORDEM_TELA",
            camposSelect: ["NOME_ORD_SIST"],
            where: [`NOME_TELA = 'RelEstoqueMat' AND ORDEM = ${ordem}`]
        };
        const json = await retornaJsonPesquisaPadrao(JSON.stringify(pesquisa));
        resultado = json[0].NOME_ORD_SIST;
        return resultado.replaceAll(';', ',')
    }
});