$(document).ready(async function () {

    $('#btnFiltrosRel').on('click', async function () {
        $('#modal-filtros').modal('show');
        limpaFiltros();

        const parametrosVenda = await BuscaParametrosVenda();

        if (parametrosVenda[17] == '1') {
            $('#radioProduto').prop('checked', false);
            $('#radioMaterial').prop('checked', true);
        } else {
            $('#radioProduto').prop('checked', true);
            $('#radioMaterial').prop('checked', false);
        };

        criaPesquisaAutoCompletaELimpaCampo();
    });

    $('#btnLimpaFiltros').on('click', async function () {
        limpaFiltros();
    });

    $('#btnConsultar').on('click', async function () {
        await fazConsulta();
    });

    async function fazConsulta() {

        if ($.fn.DataTable.isDataTable('#tabelaPecasFaturadas')) {
            $('#tabelaPecasFaturadas').DataTable().destroy();
            $('#tabelaPecasFaturadas').empty();
        };

        const url = `/sisplan/impressao/v1/imprimirrelpecasfat?`;
        const filtros = await retornaFiltros();
        const response = await requisicao('GET', url, `${filtros}&COD_USUARIO=${getCookie('cod_usuario')}`, '', 360000);

        if (!response) {
            return;
          };
  
          const jsonStr = await response.json();

          if (response != 200) {
            msgAlerta(jsonStr.mensagem);
            return;
          };
    };

    $('#btnCarregaEmpresas').on('click', function () {
        carregaEmpresasDisponiveis();
    });

    async function retornaFiltros() {

        const dataEmissaoNFIni = $('#txtDataEmissaoNFI').val();
        const dataEmissaoNFFim = $('#txtDataEmissaoNFF').val();
        const tipoItemFiltrado = $('#radioMaterial').is(':checked') ? 'M' : 'P';
        const produtoFiltrado = await formataListas($('#listaProduto').val());
        const clienteFiltrado = await formataListas($('#listaCliente').val());
        const grupoMatFiltrado = await formataListas($('#listaGrupoMat').val());
        const subGrupoMatFiltrado = await formataListas($('#listaSubgrupoMat').val());
        const represenFiltrado = await formataListas($('#listaRepresentante').val());
        const grupoCliFiltrado = await formataListas($('#listaGrupoCli').val());
        const grupoProdFiltrado = await formataListas($('#listaGrupo').val());
        const composicaoFiltrado = await formataListas($('#listaComposicao').val());
        const ncmFiltrado = await formataListas($('#listaNCM').val());
        const coordFiltrado = await formataListas($('#listaCoord').val());
        const depositoFiltrado = await formataListas($('#listaDeposito').val());
        const moedaFiltrado = await formataListas($('#listaMoeda').val());
        const linhaMatFiltrado = await formataListas($('#listaLinhaMat').val());
        const linhaFiltrado = await formataListas($('#listaLinha').val());
        const nfFiltrado = await formataListas($('#listaNF').val());
        const colecaoProdFiltrado = await formataListas($('#listaColecaoProd').val());
        const colecaoPedFiltrado = await formataListas($('#listaColecaoPed').val());
        const tipoVendaFiltrado = await formataListas($('#listaTipoVenda').val());
        const estilistaFiltrado = await formataListas($('#listaEstilista').val());
        const marcaFiltrado = await formataListas($('#listaMarca').val());
        const pedidoFiltrado = await formataListas($('#listaPedido').val());
        const estadoFiltrado = await formataListas($('#listaEstado').val());
        const naturezaFiltrado = await formataListas($('#listaNatureza').val());
        const consideraNatureza = $('#cbConsideraNatureza').is(':checked');
        const prazoEntFiltrado = await formataListas($('#listaPrazoEnt').val());
        const loteFiltrado = $('#txtLote').val();
        const motivoFiltrado = await formataListas($('#listaMotivo').val());
        const categoriaFiltrado = await formataListas($('#listaCategoria').val());
        const etiquetaFiltrado = await formataListas($('#listaEtiqueta').val());
        const percCofins = $('#txtCofins').val();
        const percPis = $('#txtPis').val();
        const consideraCategoria = $('#selectTipoEntidade').val();
        const naoMostraNfeDev = $('#cbMostraOuNaoNFEDevolucao').is(':checked');
        const consideraFatorConv = $('#cbConsideraFatorConversao').is(':checked');
        const empresasFiltradas = $('.empresa_selecionada:checked').toArray().length > 0 ? $('.empresa_selecionada:checked').toArray().map(input => input.id.substring(input.id.indexOf('-') + 1, input.id.length))
        : [getCookie('emp_id')];

        const empresasFiltradasFormatada = await formataListas(empresasFiltradas);

        ///Notas
        let tipoNotas;

        if ($('#cbTodas').is(':checked')) {
            tipoNotas = $('#cbTodas').val();
        } else if ($('#cbNormais').is(':checked')) {
            tipoNotas = $('#cbNormais').val();
        } else if ($('#cbNormais-Den-Canc').is(':checked')) {
            tipoNotas = $('#cbNormais-Den-Canc').val();
        } else if ($('#cbNormais-Den').is(':checked')) {
            tipoNotas = $('#cbNormais-Den').val();
        } else if ($('#cbNormais-Canc').is(':checked')) {
            tipoNotas = $('#cbNormais-Canc').val();
        } else {
            tipoNotas = '';
        }

        ///Duplicatas
        let tipoDuplicatas;

        if ($('#cbTodasDups').is(':checked')) {
            tipoDuplicatas = $('#cbTodasDups').val();
        } else if ($('#cbComDups').is(':checked')) {
            tipoDuplicatas = $('#cbComDups').val();
        } else if ($('#cbSemDups').is(':checked')) {
            tipoDuplicatas = $('#cbSemDups').val();
        } else {
            tipoDuplicatas = '';
        }

        //Filtro
        let tipoFiltro;

        if ($('#cbTodosFiltros').is(':checked')) {
            tipoFiltro = $('#cbTodosFiltros').val();
        } else if ($('#cbProduto').is(':checked')) {
            tipoFiltro = $('#cbProduto').val();
        } else if ($('#cbMaterial').is(':checked')) {
            tipoFiltro = $('#cbMaterial').val();
        } else if ($('#cbServico').is(':checked')) {
            tipoFiltro = $('#cbServico').val();
        } else {
            tipoFiltro = '';
        }

        //Inss
        let tipoInss;

        if ($('#cbTodosInss').is(':checked')) {
            tipoInss = $('#cbTodosInss').val();
        } else if ($('#cbComInss').is(':checked')) {
            tipoInss = $('#cbComInss').val();
        } else if ($('#cbSemInss').is(':checked')) {
            tipoInss = $('#cbSemInss').val();
        } else {
            tipoInss = '';
        }

        ///tipos de Natureza
        let tiposNatureza = [];

        if ($('#cbVendaCompra').is(':checked')) {
            tiposNatureza.push($('#cbVendaCompra').val());
        };
        if ($('#cbDevolucao').is(':checked')) {
            tiposNatureza.push($('#cbDevolucao').val());
        };
        if ($('#cbRemessa').is(':checked')) {
            tiposNatureza.push($('#cbRemessa').val());
        };
        if ($('#cbRetorno').is(':checked')) {
            tiposNatureza.push($('#cbRetorno').val());
        };
        if ($('#cbConsignacao').is(':checked')) {
            tiposNatureza.push($('#cbConsignacao').val());
        };
        if ($('#cbAntecipacao').is(':checked')) {
            tiposNatureza.push($('#cbAntecipacao').val());
        };
        if ($('#cbServicos').is(':checked')) {
            tiposNatureza.push($('#cbServicos').val());
        };
        if ($('#cbEnergiaTelefone').is(':checked')) {
            tiposNatureza.push($('#cbEnergiaTelefone').val());
        };
        if ($('#cbBonificacao').is(':checked')) {
            tiposNatureza.push($('#cbBonificacao').val());
        };
        if ($('#cbPatrimonio').is(':checked')) {
            tiposNatureza.push($('#cbPatrimonio').val());
        };
        if ($('#cbEstornoImposto').is(':checked')) {
            tiposNatureza.push($('#cbEstornoImposto').val());
        };

        tiposNatureza = await formataListas(tiposNatureza.toString());

     

        //tipos de Categoria de Entidade
        let clienteEstaCheck = false;
        let fornecedorEstaCheck = false;
        let terceirosEstaCheck = false;

        if ($('#cbCliente').is(':checked')) {
            clienteEstaCheck = true;
        };

        if ($('#cbFornecedor').is(':checked')) {
            fornecedorEstaCheck = true;
        };

        if ($('#cbTerceiros').is(':checked')) {
            terceirosEstaCheck = true;
        };


        const filtros = `DTEMISSAONFINI=${dataEmissaoNFIni}&`+
                        `DTEMISSAONFFIM=${dataEmissaoNFFim}&`+
                        `ITEMFILTRADO=${produtoFiltrado}&`+
                        `TIPOITEMFILTRADO=${tipoItemFiltrado}&`
                        `CLIENTEFILTRADO=${clienteFiltrado}&`+
                        `GRUPOMATFILTRADO=${grupoMatFiltrado}&`+
                        `SUBGRUPOMATFILTRADO=${subGrupoMatFiltrado}&`+
                        `REPRESENTANTEFILTRADO=${represenFiltrado}&`+       
                        `GRUPOCLIFILTRADO=${grupoCliFiltrado}&`+
                        `GRUPOPRODFILTRADO=${grupoProdFiltrado}&`+
                        `COMPOSICAOFILTRADO=${composicaoFiltrado}&`+
                        `NCMFILTRADO=${ncmFiltrado}&`+
                        `COORDFILTRADO=${coordFiltrado}&`+
                        `DEPOSITOFILTRADO=${depositoFiltrado}&`+
                        `MOEDAFILTRADO=${moedaFiltrado}&`+
                        `LINHAMATFILTRADO=${linhaMatFiltrado}&`+
                        `LINHAFILTRADO=${linhaFiltrado}&`+
                        `NFFILTRADO=${nfFiltrado}&`+
                        `COLECAOPRODFILTRADO=${colecaoProdFiltrado}&`+
                        `COLECAOPEDFILTRADO=${colecaoPedFiltrado}&`+
                        `TIPOVENDAFILTRADO=${tipoVendaFiltrado}&`+
                        `ESTILISTAFILTRADO=${estilistaFiltrado}&`+
                        `MARCAFILTRADO=${marcaFiltrado}&`+
                        `PEDIDOFILTRADO=${pedidoFiltrado}&`+
                        `ESTADOFILTRADO=${estadoFiltrado}&`+
                        `NATUREZAFILTRADO=${naturezaFiltrado}&`+
                        `CONSIDERANATUREZA=${consideraNatureza}&`+
                        `PRAZOENTFILTRADO=${prazoEntFiltrado}&`+
                        `LOTEFILTRADO=${loteFiltrado}&`+
                        `MOTIVOFILTRADO=${motivoFiltrado}&`+
                        `CATEGORIAFILTRADO=${categoriaFiltrado}&`+
                        `ETIQUETAFILTRADO=${etiquetaFiltrado}&`+
                        `PERCCOFINS=${percCofins}&`+
                        `PERCPIS=${percPis}&`+
                        `CONSIDERACATEGORIA=${consideraCategoria}&`+
                        `NAOMOSTRANFDEV=${naoMostraNfeDev}&`+
                        `CONSIDERAFATORCONV=${consideraFatorConv}&`+
                        `EMPRESASFILTRADAS=${empresasFiltradasFormatada}&`+
                        `TIPONOTASFILTRADO=${tipoNotas}&`+
                        `TIPODUPLICATASFILTRADO=${tipoDuplicatas}&`+
                        `TIPOFILTROFILTRADO=${tipoFiltro}&`+
                        `TIPOINSSFILTRADO=${tipoInss}&`+
                        `NATUREZASFILTRADAS=${tiposNatureza.toString()}&`+
                        `CLIENTEESTACHECK=${clienteEstaCheck}&`+
                        `FORNECEDORESTACHECK=${fornecedorEstaCheck}&`+
                        `TERCEIROSESTACHECK=${terceirosEstaCheck}&`
                        `UTILIZAPARTEDOLOTE=${$('#cbUtilizaPartedoLote').is(':checked')}&`+
                        `NATDEVOLUCAO=${$('#cbDevolucao').is(':checked')}&`+
                        `TODASEMPRESAS=${$('#cbTodasAsEmpresas').is(':checked')}`    
                   

        return filtros;

    };




    function criaPesquisaAutoCompletaELimpaCampo() {

        $('#btnConsultaProduto').pesquisa_serverside(['#txtProduto'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"PRODUTO", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de Produto');
        $('#btnConsultaCliente').pesquisa_serverside(['#txtCliente'], ['CODCLI'], ['NOME'], '{"tabela":"ENTIDADE", "camposSelect":[ "CODCLI", "NOME"], "where": null}', 'Pesquisa de Cliente');
        $('#btnConsultaGrupoMat').pesquisa_serverside(['#txtGrupoMat'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"GRUPO_MA", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de Grupo de Material');
        $('#btnConsultaSubgrupoMat').pesquisa_serverside(['#txtSubgrupoMat'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"SUBGRUPO_MA", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de SubGrupo de Material');
        $('#btnConsultaRepresen').pesquisa_serverside(['#txtRepresentante'], ['CODREP'], ['NOME'], '{"tabela":"REPRESEN", "camposSelect":[ "CODREP", "NOME"], "where": null}', 'Pesquisa de Representante');
        $('#btnConsultaGrupoCli').pesquisa_serverside(['#txtGrupoCli'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"GRUPO_CLI", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de Grupo de Cliente');
        $('#btnConsultaGrupoProd').pesquisa_serverside(['#txtGrupo'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"GRUPO_PA", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de Grupo de Produto');
        $('#btnConsultaComposicao').pesquisa_serverside(['#txtComposicao'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"CADCOMPOSI", "camposSelect":[ "CODIGO", "DESCRICAO"], "where": null}', 'Pesquisa de Composição');
        $('#btnConsultaNCM').pesquisa_serverside(['#txtNCM'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"TABFIS", "camposSelect":[ "CODIGO", "DESCRICAO", "TIPO"], "where": null}', 'Pesquisa de NCM');
        $('#btnConsultaCoord').pesquisa_serverside(['#txtCoord'], ['CODCLI'], ['NOME'], '{"tabela":"ENTIDADE", "camposSelect":[ "CODCLI", "NOME"], "where": null}', 'Pesquisa de Coord.');
        $('#btnConsultaDeposito').pesquisa_serverside(['#txtDeposito'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"DEPOSITO", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Depósito');
        $('#btnConsultaMoeda').pesquisa_serverside(['#txtMoeda'], ['CODMOE'], ['DESCRICAO'], '{"tabela":"MOEDA", "camposSelect":[ "DESCRICAO", "CODMOE"], "where": null}', 'Pesquisa de Moeda');
        $('#btnConsultaLinhaMat').pesquisa_serverside(['#txtLinhaMat'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"TABLIN", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Linha');
        $('#btnConsultaLinha').pesquisa_serverside(['#txtLinha'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"TABLIN", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Linha');
        $('#btnConsultaNF').pesquisa_serverside(['#txtNF'], ['FATURA'], ['SERIE'], '{"tabela":"NOTA", "camposSelect":[ "FATURA", "SERIE", "DT_EMISSAO"], "where": null}', 'Pesquisa de Nota Fiscal');
        $('#btnConsultaColecaoProd').pesquisa_serverside(['#txtColecaoProd'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"COLECAO", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Coleção');
        $('#btnConsultaColecaoPed').pesquisa_serverside(['#txtColecaoPed'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"COLECAO", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Coleção');
        $('#btnConsultaTipoVenda').pesquisa_serverside(['#txtTipoVenda'], ['ID'], ['DESCRICAO'], '{"tabela":"VENDA_TIPO", "camposSelect":[ "DESCRICAO", "ID"], "where": null}', 'Pesquisa de Tipo de Venda');
        $('#btnConsultaEstilista').pesquisa_serverside(['#txtEstilista'], ['CODIGO'], ['NOME'], '{"tabela":"PESSOAL", "camposSelect":[ "CODIGO", "NOME"], "where": null}', 'Pesquisa de Estilista');
        $('#btnConsultaMarca').pesquisa_serverside(['#txtMarca'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"MARCA", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Marca');
        $('#btnConsultaPedido').pesquisa_serverside(['#txtPedido'], ['NUMERO'], ['CODCLI'], '{"tabela":"PEDIDO", "camposSelect":[ "NUMERO", "CODCLI"], "where": null}', 'Pesquisa de Pedido');
        $('#btnConsultaEstado').pesquisa_serverside(['#txtEstado'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"TABUF", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Estado');
        $('#btnConsultaNatureza').pesquisa_serverside(['#txtNatureza'], ['NATUREZA'], ['DESCRICAO'], '{"tabela":"NATUREZA", "camposSelect":[ "DESCRICAO", "NATUREZA"], "where": null}', 'Pesquisa de Natureza');
        $('#btnConsultaPrazoEnt').pesquisa_serverside(['#txtPrazoEnt'], ['PRAZO'], ['DESCRICAO'], '{"tabela":"TABPRZ", "camposSelect":[ "DESCRICAO", "PRAZO"], "where": null}', 'Pesquisa de Prazo de Entrega');
        $('#btnConsultaMotivo').pesquisa_serverside(['#txtMotivo'], ['CODMEN'], ['DESCRICAO'], '{"tabela":"MENSAGEM", "camposSelect":[ "DESCRICAO", "CODMEN"], "where": null}', 'Pesquisa de Motivo');
        $('#btnConsultaCategoria').pesquisa_serverside(['#txtCategoria'], ['ID'], ['DESCRICAO'], '{"tabela":"AUXILIAR", "camposSelect":[ "DESCRICAO", "ID"], "where": null}', 'Pesquisa de Categoria');
        $('#btnConsultaEtiqueta').pesquisa_serverside(['#txtEtiqueta'], ['CODIGO'], ['DESCRICAO'], '{"tabela":"ETQ_PROD", "camposSelect":[ "DESCRICAO", "CODIGO"], "where": null}', 'Pesquisa de Etiqueta');

        $('#txtProduto').autocompleta(1, 'JSON={ "tabela":"PRODUTO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtCliente').autocompleta(1, 'JSON={ "tabela":"ENTIDADE", "camposSelect":[ "CODCLI CHAVE", "NOME DESCRICAO"], "where": null}');
        $('#txtGrupoMat').autocompleta(1, 'JSON={ "tabela":"GRUPO_MA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtSubgrupoMat').autocompleta(1, 'JSON={ "tabela":"SUBGRUPO_MA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtRepresentante').autocompleta(1, 'JSON={ "tabela":"REPRESEN", "camposSelect":[ "CODREP CHAVE", "NOME DESCRICAO"], "where": null}');
        $('#txtGrupoCli').autocompleta(1, 'JSON={ "tabela":"GRUPO_CLI", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtGrupo').autocompleta(1, 'JSON={ "tabela":"GRUPO_PA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtComposicao').autocompleta(1, 'JSON={ "tabela":"CADCOMPOSI", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtNCM').autocompleta(1, 'JSON={ "tabela":"TABFIS", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtCoord').autocompleta(1, 'JSON={ "tabela":"ENTIDADE", "camposSelect":[ "CODCLI CHAVE", "NOME DESCRICAO"], "where": null}');
        $('#txtDeposito').autocompleta(1, 'JSON={ "tabela":"DEPOSITO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtMoeda').autocompleta(1, 'JSON={ "tabela":"MOEDA", "camposSelect":[ "CODMOE CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtLinhaMat').autocompleta(1, 'JSON={ "tabela":"TABLIN", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtLinha').autocompleta(1, 'JSON={ "tabela":"TABLIN", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtNF').autocompleta(1, 'JSON={ "tabela":"NOTA", "camposSelect":[ "FATURA CHAVE", "SERIE DESCRICAO"], "where": null}');
        $('#txtColecaoProd').autocompleta(1, 'JSON={ "tabela":"COLECAO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtColecaoPed').autocompleta(1, 'JSON={ "tabela":"COLECAO", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtTipoVenda').autocompleta(1, 'JSON={ "tabela":"VENDA_TIPO", "camposSelect":[ "ID CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtEstilista').autocompleta(1, 'JSON={ "tabela":"PESSOAL", "camposSelect":[ "CODIGO CHAVE", "NOME DESCRICAO"], "where": null}');
        $('#txtMarca').autocompleta(1, 'JSON={ "tabela":"MARCA", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtPedido').autocompleta(1, 'JSON={ "tabela":"PEDIDO", "camposSelect":[ "NUMERO CHAVE", "CODCLI DESCRICAO"], "where": null}');
        $('#txtEstado').autocompleta(1, 'JSON={ "tabela":"TABUF", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtNatureza').autocompleta(1, 'JSON={ "tabela":"NATUREZA", "camposSelect":[ "NATUREZA CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtPrazoEnt').autocompleta(1, 'JSON={ "tabela":"TABPRZ", "camposSelect":[ "PRAZO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtMotivo').autocompleta(1, 'JSON={ "tabela":"MENSAGEM", "camposSelect":[ "CODMEN CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtCategoria').autocompleta(1, 'JSON={ "tabela":"AUXILIAR", "camposSelect":[ "ID CHAVE", "DESCRICAO DESCRICAO"], "where": null}');
        $('#txtEtiqueta').autocompleta(1, 'JSON={ "tabela":"ETQ_PROD", "camposSelect":[ "CODIGO CHAVE", "DESCRICAO DESCRICAO"], "where": null}');

        $('#txtProduto').listaFiltros();
        $('#txtCliente').listaFiltros();
        $('#txtGrupoMat').listaFiltros();
        $('#txtSubgrupoMat').listaFiltros();
        $('#txtRepresentante').listaFiltros();
        $('#txtGrupoCli').listaFiltros();
        $('#txtGrupo').listaFiltros();
        $('#txtComposicao').listaFiltros();
        $('#txtNCM').listaFiltros();
        $('#txtCoord').listaFiltros();
        $('#txtDeposito').listaFiltros();
        $('#txtMoeda').listaFiltros();
        $('#txtLinhaMat').listaFiltros();
        $('#txtLinha').listaFiltros();
        $('#txtNF').listaFiltros();
        $('#txtColecaoProd').listaFiltros();
        $('#txtColecaoPed').listaFiltros();
        $('#txtTipoVenda').listaFiltros();
        $('#txtEstilista').listaFiltros();
        $('#txtMarca').listaFiltros();
        $('#txtPedido').listaFiltros();
        $('#txtEstado').listaFiltros();
        $('#txtNatureza').listaFiltros();
        $('#txtPrazoEnt').listaFiltros();
        $('#txtMotivo').listaFiltros();
        $('#txtCategoria').listaFiltros();
        $('#txtEtiqueta').listaFiltros();

        
        $('#btnLimpaProduto').on('click', function () {
            if ($('#txtProduto').val() == '') {
                $('#listaProduto').val('');
            }
            $('#txtProduto').val('');
            $('#txtProduto').focus();
        });

        $('#btnLimpaCliente').on('click', function () {
            if ($('#txtCliente').val() == '') {
                $('#listaCliente').val('');
            }
            $('#txtCliente').val('');
            $('#txtCliente').focus();
        });

        $('#btnLimpaGrupoMat').on('click', function () {
            if ($('#txtGrupoMat').val() == '') {
                $('#listaGrupoMat').val('');
            }
            $('#txtGrupoMat').val('');
            $('#txtGrupoMat').focus();
        });

        $('#btnLimpaSubgrupoMat').on('click', function () {
            if ($('#txtSubgrupoMat').val() == '') {
                $('#listaSubgrupoMat').val('');
            }
            $('#txtSubgrupoMat').val('');
            $('#txtSubgrupoMat').focus();
        });

        $('#btnLimpaRepresen').on('click', function () {
            if ($('#txtRepresentante').val() == '') {
                $('#listaRepresentante').val('');
            }
            $('#txtRepresentante').val('');
            $('#txtRepresentante').focus();
        });

        $('#btnLimpaGrupoCli').on('click', function () {
            if ($('#txtGrupoCli').val() == '') {
                $('#listaGrupoCli').val('');
            }
            $('#txtGrupoCli').val('');
            $('#txtGrupoCli').focus();
        });

        $('#btnLimpaGrupoProd').on('click', function () {
            if ($('#txtGrupo').val() == '') {
                $('#listaGrupo').val('');
            }
            $('#txtGrupo').val('');
            $('#txtGrupo').focus();
        });

        $('#btnLimpaComposicao').on('click', function () {
            if ($('#txtComposicao').val() == '') {
                $('#listaComposicao').val('');
            }
            $('#txtComposicao').val('');
            $('#txtComposicao').focus();
        });

        $('#btnLimpaNCM').on('click', function () {
            if ($('#txtNCM').val() == '') {
                $('#listaNCM').val('');
            }
            $('#txtNCM').val('');
            $('#txtNCM').focus();
        });

        $('#btnLimpaCoord').on('click', function () {
            if ($('#txtCoord').val() == '') {
                $('#listaCoord').val('');
            }
            $('#txtCoord').val('');
            $('#txtCoord').focus();
        });

        $('#btnLimpaDeposito').on('click', function () {
            if ($('#txtDeposito').val() == '') {
                $('#listaDeposito').val('');
            }
            $('#txtDeposito').val('');
            $('#txtDeposito').focus();
        });

        $('#btnLimpaLinhaMat').on('click', function () {
            if ($('#txtLinhaMat').val() == '') {
                $('#listaLinhaMat').val('');
            }
            $('#txtLinhaMat').val('');
            $('#txtLinhaMat').focus();
        });

        $('#btnLimpaLinha').on('click', function () {
            if ($('#txtLinha').val() == '') {
                $('#listaLinha').val('');
            }
            $('#txtLinha').val('');
            $('#txtLinha').focus();
        });

        $('#btnLimpaNF').on('click', function () {
            if ($('#txtNF').val() == '') {
                $('#listaNF').val('');
            }
            $('#txtNF').val('');
            $('#txtNF').focus();
        });

        $('#btnLimpaColecaoProd').on('click', function () {
            if ($('#txtColecaoProd').val() == '') {
                $('#listaColecaoProd').val('');
            }
            $('#txtColecaoProd').val('');
            $('#txtColecaoProd').focus();
        });

        $('#btnLimpaColecaoPed').on('click', function () {
            if ($('#txtColecaoPed').val() == '') {
                $('#listaColecaoPed').val('');
            }
            $('#txtColecaoPed').val('');
            $('#txtColecaoPed').focus();
        });

        $('#btnLimpaColecaoPed').on('click', function () {
            if ($('#txtColecaoPed').val() == '') {
                $('#listaColecaoPed').val('');
            }
            $('#txtColecaoPed').val('');
            $('#txtColecaoPed').focus();
        });

        $('#btnLimpaColecaoPed').on('click', function () {
            if ($('#txtColecaoPed').val() == '') {
                $('#listaColecaoPed').val('');
            }
            $('#txtColecaoPed').val('');
            $('#txtColecaoPed').focus();
        });

        $('#btnLimpaMarca').on('click', function () {
            if ($('#txtMarca').val() == '') {
                $('#listaMarca').val('');
            }
            $('#txtMarca').val('');
            $('#txtMarca').focus();
        });

        $('#btnLimpaPedido').on('click', function () {
            if ($('#txtPedido').val() == '') {
                $('#listaPedido').val('');
            }
            $('#txtPedido').val('');
            $('#txtPedido').focus();
        });

        $('#btnLimpaNatureza').on('click', function () {
            if ($('#txtNatureza').val() == '') {
                $('#listaNatureza').val('');
            }
            $('#txtNatureza').val('');
            $('#txtNatureza').focus();
        });

        $('#btnLimpaPrazoEnt').on('click', function () {
            if ($('#txtPrazoEnt').val() == '') {
                $('#listaPrazoEnt').val('');
            }
            $('#txtPrazoEnt').val('');
            $('#txtPrazoEnt').focus();
        });


        $('#btnLimpaMotivo').on('click', function () {
            if ($('#txtMotivo').val() == '') {
                $('#listaMotivo').val('');
            }
            $('#txtMotivo').val('');
            $('#txtMotivo').focus();
        });

        $('#btnLimpaCategoria').on('click', function () {
            if ($('#txtCategoria').val() == '') {
                $('#listaCategoria').val('');
            }
            $('#txtCategoria').val('');
            $('#txtCategoria').focus();
        });

        $('#btnLimpaEtiqueta').on('click', function () {
            if ($('#txtEtiqueta').val() == '') {
                $('#listaEtiqueta').val('');
            }
            $('#txtEtiqueta').val('');
            $('#txtEtiqueta').focus();
        });
    };

    ///tem pouco filtro graças a Deus
    function limpaFiltros() {
        $('#txtProduto').val('');
        $('#listaProduto').val('');
        $('#txtProduto').focusout();
        $('#listaProduto').focusout();
        $('#txtCliente').val('');
        $('#listaCliente').val('');
        $('#txtCliente').focusout();
        $('#listaCliente').focusout();
        $('#txtGrupoMat').val('');
        $('#listaGrupoMat').val('');
        $('#txtGrupoMat').focusout();
        $('#listaGrupoMat').focusout();
        $('#txtSubgrupoMat').val('');
        $('#listaSubgrupoMat').val('');
        $('#txtSubgrupoMat').focusout();
        $('#listaSubgrupoMat').focusout();
        $('#txtRepresentante').val('');
        $('#listaRepresentante').val('');
        $('#txtRepresentante').focusout();
        $('#listaRepresentante').focusout();
        $('#txtGrupoCli').val('');
        $('#listaGrupoCli').val('');
        $('#txtGrupoCli').focusout();
        $('#listaGrupoCli').focusout();
        $('#txtGrupo').val('');
        $('#listaGrupo').val('');
        $('#txtGrupo').focusout();
        $('#listaGrupo').focusout();
        $('#txtComposicao').val('');
        $('#listaComposicao').val('');
        $('#txtComposicao').focusout();
        $('#listaComposicao').focusout();
        $('#txtNCM').val('');
        $('#listaNCM').val('');
        $('#txtNCM').focusout();
        $('#listaNCM').focusout();
        $('#txtCoord').val('');
        $('#listaCoord').val('');
        $('#txtCoord').focusout();
        $('#listaCoord').focusout();
        $('#txtDeposito').val('');
        $('#listaDeposito').val('');
        $('#txtDeposito').focusout();
        $('#listaDeposito').focusout();
        $('#txtMoeda').val('');
        $('#listaMoeda').val('');
        $('#txtMoeda').focusout();
        $('#listaMoeda').focusout();
        $('#txtLinhaMat').val('');
        $('#listaLinhaMat').val('');
        $('#txtLinhaMat').focusout();
        $('#listaLinhaMat').focusout();
        $('#txtLinha').val('');
        $('#listaLinha').val('');
        $('#txtLinha').focusout();
        $('#listaLinha').focusout();
        $('#txtNF').val('');
        $('#listaNF').val('');
        $('#txtNF').focusout();
        $('#listaNF').focusout();
        $('#txtColecaoProd').val('');
        $('#listaColecaoProd').val('');
        $('#txtColecaoProd').focusout();
        $('#listaColecaoProd').focusout();
        $('#txtColecaoPed').val('');
        $('#listaColecaoPed').val('');
        $('#txtColecaoPed').focusout();
        $('#listaColecaoPed').focusout();
        $('#txtTipoVenda').val('');
        $('#listaTipoVenda').val('');
        $('#txtTipoVenda').focusout();
        $('#listaTipoVenda').focusout();
        $('#txtEstilista').val('');
        $('#listaEstilista').val('');
        $('#txtEstilista').focusout();
        $('#listaEstilista').focusout();
        $('#txtMarca').val('');
        $('#listaMarca').val('');
        $('#txtMarca').focusout();
        $('#listaMarca').focusout();
        $('#txtPedido').val('');
        $('#listaPedido').val('');
        $('#txtPedido').focusout();
        $('#listaPedido').focusout();
        $('#txtNatureza').val('');
        $('#listaNatureza').val('');
        $('#txtNatureza').focusout();
        $('#listaNatureza').focusout();
        $('#txtPrazoEnt').val('');
        $('#listaPrazoEnt').val('');
        $('#txtPrazoEnt').focusout();
        $('#listaPrazoEnt').focusout();
        $('#txtMotivo').val('');
        $('#listaMotivo').val('');
        $('#txtMotivo').focusout();
        $('#listaMotivo').focusout();
        $('#txtCategoria').val('');
        $('#listaCategoria').val('');
        $('#txtCategoria').focusout();
        $('#listaCategoria').focusout();
        $('#txtEtiqueta').val('');
        $('#listaEtiqueta').val('');
        $('#txtEtiqueta').focusout();
        $('#listaEtiqueta').focusout();
        $('#txtLote').val('');
        $('#txtDataEmissaoNFI').val('1200-01-01');
        $('#txtDataEmissaoNFF').val('2500-12-01');
        $('#cbVendaCompra').prop('checked', false);
        $('#cbDevolucao').prop('checked', false);
        $('#cbRemessa').prop('checked', false);
        $('#cbRetorno').prop('checked', false);
        $('#cbConsignacao').prop('checked', false);
        $('#cbAntecipacao').prop('checked', false);
        $('#cbServicos').prop('checked', false);
        $('#cbEnergiaTelefone').prop('checked', false);
        $('#cbBonificacao').prop('checked', false);
        $('#cbPatrimonio').prop('checked', false);
        $('#cbEstornoImposto').prop('checked', false);
        $('#cbMostraOuNaoNFEDevolucao').prop('checked', false);
        $('#cbConsideraFatorConversao').prop('checked', false);
        $('#cbConsideraNatureza').prop('checked', true);
        $('#cbTodosInss').prop('checked', true);
        $('#cbComInss').prop('checked', false);
        $('#cbUtilizaPartedoLote').prop('checked', false);
        $('#cbSemInss').prop('checked', false);
        $('#cbCliente').prop('checked', false);
        $('#cbFornecedor').prop('checked', false);
        $('#cbTerceiros').prop('checked', false);
        $('#cbNormais').prop('checked', true);
        $('#cbTodosFiltros').prop('checked', true);
        $('#cbTodasDups').prop('checked', true);
        $('#selectTipoEntidade').val('considerartipoEntidade');
    };








































})













































