$(document).ready(async function () {

  $('#tutorial').on('click', function () {
    $(document).ready(async function () {
      const driver = new Driver({
        doneBtnText: 'Sair',
        closeBtnText: 'Fechar',
        nextBtnText: 'Próximo',
        prevBtnText: 'Anterior',
        allowClose: false
      });
      driver.defineSteps([{
        element: '#btnFiltros',
        popover: {
          title: 'Botão Filtros',
          description: 'Clique aqui para abrir os filtros e realizar uma consulta.',
          position: 'right'
        }
      },
      {
        element: '#btnImprimir',
        popover: {
          title: 'Botão Imprimir',
          description: 'Clique aqui para imprimir um relatório.',
          position: 'right'
        }
      },
      {
        element: '#divTabelaVendas',
        popover: {
          title: 'Tabela Receber',
          description: 'Aqui, após clicar em consultar ficam os dados das duplicatas filtradas.',
          position: 'bottom'
        }
      }
      ]);
      driver.start();
    });
  });

  preencheOrdenacaoTela('RelReceber');

  $('#txtClasse').autocompleta(1, `JSON={ "tabela":"classe_ger", "camposSelect":[ "codigo chave", "descricao"], "where": null}`);
  $('#txtClienteConsulta').autocompleta(3, `JSON={ "tabela":"entidade", "camposSelect":[ "codcli chave", "nome descricao"], "where": null}`);
  $('#txtRepresentanteConsulta').autocompleta(3, `JSON={ "tabela":"represen", "camposSelect":[ "codrep chave", "nome descricao"], "where":["ativo = 'S'"]}`);
  $('#txtMoeda').autocompleta(1, `JSON={ "tabela":"moeda", "camposSelect":[ "codmoe chave", "descricao descricao"], "where": null}`);
  $('#txtCaixa').autocompleta(1, `JSON={ "tabela":"caixa_loja", "camposSelect":[ "codigo CHAVE", "descricao"], "where": null}`);
  $('#txtHistorico').autocompleta(1, `JSON={ "tabela":"histcp", "camposSelect":[ "historico chave", "descricao descricao"], "where": null}`);

  $('#btn-Classe').pesquisa('#txtClasse', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"classe_ger", "camposSelect":[ "codigo", "descricao"]}`, 'Pesquisa Classe', 'classe_ger');
  $('#btn-ClienteConsulta').pesquisa_serverside(['#txtClienteConsulta'], ['CODCLI'], ['NOME'], '{"tabela":"entidade", "camposSelect":[ "CODCLI", "NOME"], "where": null}', 'Pesquisa Cliente');

  $('#btn-RepresentanteConsulta').pesquisa_array(['#txtRepresentanteConsulta'], ['CODREP'], ['NOME'], `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"represen", "camposSelect":[ "codrep", "nome"], "where": ["ativo = 'S'"]}`, 'Pesquisa Representante', 'represen');
  $('#btnConsultaMoeda').pesquisa('#txtMoeda', 'CODMOE', 'DESCRICAO', '/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"MOEDA", "camposSelect":[ "CODMOE", "descricao"]}', 'Pesquisa Moeda', 'MOEDA');
  $('#btnCaixa').pesquisa('#txtCaixa', 'CODIGO', 'DESCRICAO', '/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"CAIXA_LOJA", "camposSelect":[ "CODIGO", "descricao"]}', 'Pesquisa Tabela', 'CAIXA_LOJA');
  $('#btn-Historico').pesquisa('#txtHistorico', 'HISTORICO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"histcp", "camposSelect":[ "historico", "descricao"]}`, 'Pesquisa Histórico', 'histcp');

  $('#btn-limpa-Historico').on('click', function () {
    $('#txtHistorico').val('');
  });

  $('#btn-limpa-Classe').on('click', function () {
    $('#txtClasse').val('');
  });

  $('#btn-limpa-Caixa').on('click', function () {
    $('#txtCaixa').val('');
  });

  $('#btn-limpa-ClienteConsulta').on('click', function () {
    $('#txtClienteConsulta').val('');
  });
  $('#btnLimpaMoeda').on('click', function () {
    $('#txtMoeda').val('');
  });
  $('#btn-limpa-RepresentanteConsulta').on('click', function () {
    $('#txtRepresentanteConsulta').val('');
  });

  $('#btnFiltros').on('click', async function () {
    $('#modal-filtros').modal('show');
  });

  $('#btnLimparFiltros').on('click', async function () {
    $('#txtNumero').val('');
    $('#txtFatura').val('');
    $('#txtClienteConsulta').val('');
    $('#txtRepresentanteConsulta').val('');
    $('#txtDataEmiI').val('1200-01-01');
    $('#txtDataEmiF').val('2500-12-31');
    $('#txtVenctoI').val('1200-01-01');
    $('#txtVenctoF').val('2500-12-31');
    $('#Status').val('');
    $('#txtSituacao').val('Todos');
    $('#txtMoeda').val('');
  });

  function retornaFiltros() {
    const sNumero = $('#txtNumero').val();
    const sFatura = $('#txtFatura').val();
    const sDataEmiI = $('#txtDataEmiI').val();
    const sDataEmiF = $('#txtDataEmiF').val();
    const sDataVenctoI = $('#txtVenctoI').val();
    const sDataVenctoF = $('#txtVenctoF').val();
    const sCliente = pegaChave('#txtClienteConsulta');
    const sRepresentante = pegaChave('#txtRepresentanteConsulta');
    const sStatus = $('#Status').val();
    const sSituacao = $('#txtSituacao').val();
    const sMoeda = pegaChave('#txtMoeda');
    const retorno = `NUMERO=${sNumero}`+
                    `&FATURA=${sFatura}`+
                    `&DTEMISSAOI=${sDataEmiI}`+
                    `&DTEMISSAOF=${sDataEmiF}`+
                    `&DTVENCIMENTOI=${sDataVenctoI}`+
                    `&DTVENCIMENTOF=${sDataVenctoF}`+
                    `&STATUS=${sStatus}`+
                    `&CLIENTE=${sCliente}`+
                    `&REPRESENTANTE=${sRepresentante}`+
                    `&SITUACAO=${sSituacao}`+
                    `&MOEDA=${sMoeda}`+
                    `&EMP_ID=${getCookie('emp_id')}`;
    return retorno;
  }

  $('#btnImprimir').on('click', async function () {
    try {
      $.LoadingOverlay('show');
      try {
        const url = `/sisplan/impressao/v1/relreceber?`;
        const filtros = retornaFiltros();
        const ordem = `&TELA_ORDENACAO=RelReceber&ORDEM_ORDENACAO=${$('#txtOrdem').val()}`;
        const bImprimeAutomatico = await verificaImprimirAutomatico('RelReceber');
        const arquivo = await GeraRelatorio(`${url}${filtros}${ordem}&`, 'GET', 100000, false, 'RelReceber');
        if (arquivo != undefined) {
          if (!bImprimeAutomatico) {
            window.open(`${BASE_URI}/relatorios_api/pdf/${arquivo}`, '_blank');
          }
          await limparRelatorios();
        }

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay('hide');
    }
  });

  $('#btnConsultar').on('click', async function () {
    try {
      $.LoadingOverlay('show');
      try {
        let dataSetCols = [];

        const url = '/sisplan/impressao/v1/consultarelreceber?';
        const filtros = retornaFiltros();
        const response = await requisicao('GET', url, filtros,
          null
        );

        if (!response) {
          return;
        }

        const jsonStr = await response.json();

        if (jsonStr.length == 0) {
          msgAlerta('Nenhum registro encontrado!');
          $('#txtDataEmiI').val('');
          $('#txtDataEmiF').val('');
          $('#txtVenctoI').val('');
          $('#txtVenctoF').val('');
          $('#txtNumero').val('');
          $('#txtFatura').val('');
          $('#txtClienteConsulta').val('');
          $('#txtRepresentanteConsulta').val('');
          $('#Status').val('');
          return;
        }

        if (response.status != 200) {
          console.error(jsonStr.mensagem);
          return;
        }

        let keys = Object.keys(jsonStr[0]);

        keys.forEach(k => {
          dataSetCols.push({
            'title': k,
            'data': k
          });
        });

        $('#tabelaRelReceber').DataTable({
          destroy: true,
          language: {
            sEmptyTable: 'Nenhum registro encontrado',
            sInfo: '_TOTAL_ registros',
            sInfoEmpty: ' 0 registros',
            sInfoFiltered: '(Filtrados de _MAX_ registros)',
            sInfoPostFix: '',
            sInfoThousands: '.',
            sLengthMenu: '_MENU_ resultados',
            sLoadingRecords: 'Carregando...',
            sProcessing: 'Processando...',
            sZeroRecords: 'Nenhum registro encontrado',
            sSearch: 'Pesquisar',
            oPaginate: {
              sNext: 'Próximo',
              sPrevious: 'Anterior',
              sFirst: 'Primeiro',
              sLast: 'Último',
            },
            oAria: {
              sSortAscending: ': Ordenar colunas de forma ascendente',
              sSortDescending: ': Ordenar colunas de forma descendente',
            },
          },
          autoWidth: true,
          "data": jsonStr,
          "columns": dataSetCols,
          columnDefs: [{
            "render": function (data) {
              return parseFloat(data).toLocaleString('pt-BR', {
                maximumFractionDigits: 2,
                minimumFractionDigits: 2
              });
            },
            "targets": [7,8,9,10,11,12,23]
          }],
        });

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay('hide');
      $('#modal-filtros').modal('hide');
    }
  });
});